//Determination of Intercalibration Coefficients via the Matrix Method
//========================================================================
// Idea and Code: Frederik Ruehr
// with modifications by Boris Lemmer
// Code restructured by Dag Gillberg & Jim Lacey

#ifndef MatrixMethod_cxx
#define MatrixMethod_cxx

#include "MatrixMethod.h"
#include "Math/GSLMinimizer.h"
#include "Math/Functor.h"

Str AsymMM_psFile, Result_psFile, AsymSM_psFile;

int main(int argc, char **argv) {
  // Turn off all those "Info in <TCanvas::Print>: Current canvas added ..."
  gErrorIgnoreLevel=2000;

  if (argc<6) error("Must give 6(7) arguments: config, jetAlgo, production tag, eta binning, infile, outfile, (& MC generator, if MC)");

  printf("\n Matrix method analysis settings:\n\n%12s  %-s\n%12s  %-s\n%12s  %-s\n%12s  %-s\n%12s  %-s\n%12s  %-s\n",
	 "Config:",argv[1],"jet algo:",argv[2],"production tag:",argv[3],"Eta binning:",argv[4],"Infile:",argv[5],"Outfile:",argv[6]);

 printf("\n Prefix: %12s\n",argv[7]);

  cout<<"N Input Arguments: "<<argc<<endl;

  configFN       =argv[1];
  jetAlgo        =argv[2] ;
  if (jetAlgo=="") error("No value for JetAlgo!");

  DirName = argv[3];
  _etaBinning    = argv[4];
  Str infn       = argv[5];
  outfileName    = argv[6];
  histogramNamePrefix = argv[7];
  if(!histogramNamePrefix.Contains("null")){
    histogramNamePrefix = histogramNamePrefix+"_";
  }else{
    printf("\n Judging by the provided 3dHist prefix we are running over files 3DHists produced directly from the DxAOD.\n");
    histogramNamePrefix = "";
  }
  _isMC = argc > 8 ;//infn.Contains("mc15") || infn.Contains("ythia") || infn.Contains("erwig") || infn.Contains("owheg") || infn.Contains("erpa") || infn.Contains("immy") || infn.Contains("MonteCarlo");
  printf("\n  Judging by the number of provided parameters we are running over: %s\n",_isMC?"MC":"data");
  if ( _isMC && argc<8 ) error("When running over MC, you must specify the MC generator as a 5th arg");
  if (_isMC) {
    MCgen=argv[8];
    if ( MCgen!="Pythia" && MCgen!="Herwig" && MCgen!="PythiaMinbias" && MCgen!="PowhegPythia" && MCgen!="PowhegJimmy" && MCgen!="Sherpa" && MCgen!="PowhegHerwig")
      error("Unknown MC generator: "+MCgen);
  }

  cout<<"DO SYSTEMATICS: "<<_doSystematics<<endl;

  if(_isMC && argc>9){
    _doSystematics       = false;
    cout<<"MC: DO SYSTEMATICS: "<<_doSystematics<<endl;
    _systematicShift     = argv[8];
    cout<<"SYSTEMATIC SHIFT : "<<_systematicShift<<endl;

    _systematicsFileNameSM = argv[9];
    cout<<"SM SYSTEMATIC FILE : "<<_systematicsFileNameSM<<endl;
    _systematicsFileSM = TFile::Open(_systematicsFileNameSM);
    if (_systematicsFileSM==NULL) error("Problem opening "+_systematicsFileNameSM);

    _systematicsFileNameMM = argv[10];
    cout<<"MM SYSTEMATIC FILE : "<<_systematicsFileNameMM<<endl;
    _systematicsFileMM = TFile::Open(_systematicsFileNameMM);
    if (_systematicsFileMM==NULL) error("Problem opening "+_systematicsFileNameMM);
  }

  if(!_isMC && argc>8){

    _doSystematics       = true;
    cout<<"DATA: DO SYSTEMATICS: "<<_doSystematics<<endl;
    _systematicShift     = argv[7];
    cout<<"SYSTEMATIC SHIFT : "<<_systematicShift<<endl;

    _systematicsFileNameSM = argv[8];
    cout<<"SM SYSTEMATIC FILE : "<<_systematicsFileNameSM<<endl;
    _systematicsFileSM = TFile::Open(_systematicsFileNameSM);
    if (_systematicsFileSM==NULL) error("Problem opening "+_systematicsFileNameSM);

    _systematicsFileNameMM = argv[9];
    cout<<"MM SYSTEMATIC FILE : "<<_systematicsFileNameMM<<endl;
    _systematicsFileMM = TFile::Open(_systematicsFileNameMM);
    if (_systematicsFileMM==NULL) error("Problem opening "+_systematicsFileNameMM);


  }


  if( _subtractPtclAsym && !_isMC ) {
    MCgen="PowhegPythia";
    inputTruthFileName = "";
    truthFileForData = TFile::Open(inputTruthFileName);
    cout<<" INPUT TRUTH FILE : "<<inputTruthFileName<<endl;
  }


  inputFile = TFile::Open(infn);
  if (inputFile==NULL) error("Problem opening "+infn);

  TEnv *settings =Init(configFN);

  Str hname;
	if(_isMC && !_isSlimHistos) hname = Form("%s/%s%s_J1_Asym3D_PtBin1",DirName.Data(),histogramNamePrefix.Data(),jetAlgo.Data());
  else if(_isMC && _isSlimHistos) hname = Form("%s/%s%s_allJ_Asym3D_PtBin1",DirName.Data(),histogramNamePrefix.Data(),jetAlgo.Data());
  else if(_isSlimHistos) hname = Form("%s/%s%s_HLT_j15_OR_HLT_j15_320eta490_allJ&FJ_Asym3D_PtBin1", DirName.Data(),histogramNamePrefix.Data(),jetAlgo.Data());
  else if(_isInclusionTrigComb) hname = Form("%s/%s%s_HLT_j15_OR_HLT_j15_320eta490_rawJ_Asym3D_PtBin1", DirName.Data(),histogramNamePrefix.Data(),jetAlgo.Data());
  else      hname = Form("%s/%s%s_HLT_j15_OR_HLT_j15_320eta490_RefFJ_J_Asym3D_PtBin1", DirName.Data(),histogramNamePrefix.Data(),jetAlgo.Data());

  TH3D* h3detaBins = (TH3D*)inputFile->Get(hname);
  if(h3detaBins==NULL) error(Form("Can't find histo for determining abs eta:  %s",hname.Data()));
  if(h3detaBins->GetXaxis()->GetBinLowEdge(1)>=0.0) _absEta = true;
  cout<<" MIN BIN      : "<<h3detaBins->GetXaxis()->GetBinLowEdge(1)<<endl;
  delete h3detaBins;
  cout<<" ABSOLUTE ETA : "<<_absEta<<endl;


  outfile = InitOutputFile(outfileName);

  int jetR=4; if (jetAlgo.Contains("Kt6")) jetR=6;
  StrV ptRangesStr = Vectorize(settings->GetValue(Form("PtRangesAntiKt%d",jetR),""));
  if (ptRangesStr.size()==0) error("Must specify PtRangesAntiKt for matrix minimization");

  ptRanges.clear(); _ptBins.clear();

  for (uint ri=0;ri<ptRangesStr.size();++ri) {
    //printf("Bin %d jetR=%d %s\n",i,jetR,ptRangesStr[i].Data());
    ptRanges.push_back(VectorizeD(Str(ptRangesStr[ri]).ReplaceAll("-"," ")));
    if (ptRanges[ri].size()!=2) error(Str("Problem with pT-range: ")+ptRangeStr[ri]);
    if ( ri>0 && ptRanges[ri][0]!=ptRanges[ri-1][1] )
      error(Str("pT-ranges ")+ptRangeStr[ri-1]+" and the consequative "+ptRangeStr[ri]+" doesn't connect.");
    Str etaBinKey=Form("EtaBinsMM_%s_%.0fto%.0f",_etaBinning.Data(),ptRanges[ri][0],ptRanges[ri][1]);
    _etaBinMap[ri] = VectorizeD(settings->GetValue(etaBinKey,""));
    if (_etaBinMap[ri].size()==0) error("Must specify "+etaBinKey);

    if (ri==0) add(_ptBins,ptRanges[ri][0]);
    add(_ptBins,ptRanges[ri][1]);
  }


  // for merging pTavg bins in data
  _pTBINS = VectorizeD(settings->GetValue(Form("PtBinsAntiKt%d",jetR),""));
  for (uint ri=0;ri<ptRangesStr.size();++ri) {
    float lowRange  = ptRanges[ri][0];
    float highRange = ptRanges[ri][1];
    for( int ipt=0; ipt<_pTBINS.size(); ipt++){
      if(_pTBINS[ipt]>=lowRange && _pTBINS[ipt]<=highRange){
	PtBinMap[ri].push_back( _pTBINS[ipt] );
      }
    }
  }

  for (uint ri=0;ri<ptRangesStr.size();++ri)
    for (int veci=0; veci<PtBinMap[ri].size(); veci++){
      cout<<"MAP["<<ri<<"] = "<<PtBinMap[ri][veci]<<endl;
    }


  map<int,VecD> TempetaBinMap;
  if(_absEta){
    for (uint ri=0;ri<ptRangesStr.size();++ri) {
      VecD regBINS = _etaBinMap[ri];
      VecD absBINS;
      //cout<<"ri   = "<<ri<<endl;
      for(int ieta=0; ieta<=(regBINS.size()-1)/2; ieta++){
	absBINS.push_back(regBINS[ieta+(regBINS.size()-1)/2]);
	// cout<<"etaBins["<<ieta<<"]  = "<<absBINS[ieta]<<endl;
      }

      TempetaBinMap[ri] = absBINS;
    }
    _etaBinMap = TempetaBinMap;
  }


  if(jetAlgo.Contains("Kt2")) truthJetAlgo = "AntiKt2Truth";
  if(jetAlgo.Contains("Kt3")) truthJetAlgo = "AntiKt3Truth";
  if(jetAlgo.Contains("Kt4")) truthJetAlgo = "AntiKt4Truth";
  if(jetAlgo.Contains("Kt5")) truthJetAlgo = "AntiKt5Truth";
  if(jetAlgo.Contains("Kt6")) truthJetAlgo = "AntiKt6Truth";
  if(jetAlgo.Contains("Kt7")) truthJetAlgo = "AntiKt7Truth";
  if(jetAlgo.Contains("Kt8")) truthJetAlgo = "AntiKt8Truth";


  outfile->mkdir(jetAlgo); outfile->mkdir(jetAlgo+"_Histos");
  BookHisto2D(jetAlgo+"_AvgPtAvg_vs_EtaPtAvg_SM","#LTp_{T}^{avg}#RT in each bin",_etaBinsSM,_ptBins);
  BookHisto2D(jetAlgo+"_AvgPtAvg_vs_EtaPtAvg_MM","#LTp_{T}^{avg}#RT in each bin",_etaBinsSM,_ptBins);
  BookHisto2D(jetAlgo+"_AvgEta_vs_EtaPtAvg_SM","#LT#eta_{det}#RT in each bin",_etaBinsSM,_ptBins);
  BookHisto2D(jetAlgo+"_AvgEta_vs_EtaPtAvg_MM","#LT#eta_{det}#RT in each bin",_etaBinsSM,_ptBins);

  if ( _isMC ) {
    std::cout << "Booking pTavg histograms" << std::endl;
    BookHisto(jetAlgo+"_pTavg","",_ptBins);
    for ( const auto &sample : MCsamples )
    BookHisto(jetAlgo+"_pTavg_"+sample,"",_ptBins);

    int ih=0;
    for ( const auto &sample : MCsamples ) {
      std::cout << histogramNamePrefix << jetAlgo+"_"+sample+"_PtAvg_vs_EtaDet" << std::endl;
      TH2D* tempHist = ((TH2D*)inputFile->Get(DirName+"/"+histogramNamePrefix+jetAlgo+"_"+sample+"_PtAvg_vs_EtaDet"));
      if(!tempHist) error("FAILED TO FIND " + DirName+"/"+histogramNamePrefix+jetAlgo+"_"+sample+"_PtAvg_vs_EtaDet" );

    	histos[jetAlgo+"_pTavg_"+sample] = ((TH2D*)inputFile->Get(DirName+"/"+histogramNamePrefix+jetAlgo+"_"+sample+"_PtAvg_vs_EtaDet"))->ProjectionY(jetAlgo+"_pTavg_"+sample);
    	if (ih==0) histos[jetAlgo+"_pTavg"] = ((TH2D*)inputFile->Get(DirName+"/"+histogramNamePrefix+jetAlgo+"_"+sample+"_PtAvg_vs_EtaDet"))->ProjectionY(jetAlgo+"_pTavg");
    	else
    	  histos[jetAlgo+"_pTavg"]->Add( ((TH2D*)inputFile->Get(DirName+"/"+histogramNamePrefix+jetAlgo+"_"+sample+"_PtAvg_vs_EtaDet"))->ProjectionY() );
    	ih++;
    }
    std::cout << "Got _PtAvg_vs_EtaDet hists " << std::endl;
  }


  //
  //  Create eta_probe -> (eta,pTavg) and pT_probe -> (eta,pTavg)
  //  mapping histograms here
  //


  Str previousTrigKey = "";

  for (uint ri=0;ri<ptRanges.size();++ri) {

    current_ptRange=ri;
    if (ptRanges[ri].size()!=2) error("Incorrectly specified PtRanges");

    ptmin=ptRanges[ri][0]; ptmax=ptRanges[ri][1];

    ptRangeDesc=Form("%.0f #leq p_{T}^{avg} < %.0f GeV",ptmin,ptmax);
    ptRangeStr=Form("pt%.0fto%.0f",ptmin,ptmax);

    VecD etaBins=_etaBinMap[ri];
    int NetaBins = etaBins.size()-1;

    if (_isMC) {
      MinimizeMC(etaBins);
    } else {
      // data!
      trigs.clear();
      Str trigKey = Form("AntiKt%d.%.0fto%.0f.TrigOR",jetR,ptmin,ptmax);
      Str trigSel = settings->GetValue(trigKey,""); trigSel.ReplaceAll(" ","");

      if(trigSel!="") previousTrigKey = trigKey;
      else{
	trigSel = settings->GetValue(previousTrigKey,""); trigSel.ReplaceAll(" ","");
	cout<<"using trigger: "<<trigSel<<" for pT range : "<<ptmin<<" - "<<ptmax<<endl;
      }
      if(trigSel=="") error(trigKey+" not specified in "+configFN);

      currentTrigLong=trigSel;

      /*
      trigSel.ReplaceAll("_AND_"," "); trigSel.ReplaceAll("_and_"," ");
      trigSel.ReplaceAll("_OR_"," "); trigSel.ReplaceAll("_or_"," ");
      trigSel.ReplaceAll("_","").ReplaceAll("EF","").ReplaceAll("a4tc","").ReplaceAll("FS","").ReplaceAll("L2","").ReplaceAll("had","");*/
      trigSel.ReplaceAll("_OR_"," ");
      trigs=Vectorize(trigSel);

      cout<<"trigs size   == "<<trigs.size()<<endl;
      if (trigs.size()<2) error("Current trigger selection: "+trigSel+" is not a trigOR!?");

      currentTrig="";
      if(trigs.size()>2){

	for( int trig=0; trig<trigs.size()-1; trig++){
	  if( trig%2 != 0 ){
	    currentTrig+=trigs[trig]+"AND";
	  }else{
	    currentTrig+=trigs[trig]+"OR";
	  }
	}
	currentTrig+=trigs[trigs.size()-1];

      }else{
	currentTrig=trigs[0]+"OR"+trigs[1];
      }

      printf("\n  ====================\n");
      printf(  "  ====================\n");
      printf(  "  %.0f < pTavg < %.0f GeV\n",ptmin,ptmax);
      printf(  "  current trig: %s\n",currentTrig.Data());
      if(trigs.size()>2){
	for( int trig=0; trig<trigs.size(); trig++)
	printf(  "  Trigger: %s\n",trigs[trig].Data());
      }else
      	printf(  "  Triggers: %s %s\n",trigs[0].Data(),trigs[1].Data());

      MinimizeData(etaBins);
    } // Data/MC
  }//for each pT


  outfile->cd();
  histos2d[jetAlgo+"_AvgPtAvg_vs_EtaPtAvg_SM"]->Write();
  histos2d[jetAlgo+"_AvgPtAvg_vs_EtaPtAvg_MM"]->Write();
  histos2d[jetAlgo+"_AvgEta_vs_EtaPtAvg_SM"]->Write();
  histos2d[jetAlgo+"_AvgEta_vs_EtaPtAvg_MM"]->Write();

  if ( _isMC ) {
    histos[jetAlgo+"_pTavg"]->Write();

    for ( const auto &sample : MCsamples )
      histos[jetAlgo+"_pTavg_"+sample]->Write();
  }

  /*
  vector<TH1F*> h_responseSM =  GetSMResponseHistos(settings);
  outfile->cd(jetAlgo);
  for(int i=0; i<h_responseSM.size(); i++) {
    //cout<<"hname       : "<<h_responseSM[i]->GetName()<<endl;
    h_responseSM[i]->Write();
  }
  */


  gROOT->cd();

  MakePDF(Result_psFile);
  MakePDF(AsymMM_psFile);
  MakePDF(AsymSM_psFile);
  MakePDF(AsymSM_2_psFile);


  inputFile->Close();
  outfile->Close();

  cout<<"Wrote results to " << outfileName <<endl;
  cout << endl << "All Done" << endl << endl;
} // main


void MinimizeMC(VecD etaBins) {

  cout << "in MinimizeMC" << endl;

  int N = MCsamples.size();

  int lowPtBin=-1, highPtBin=-1;

  vector<TH2F*> h2d_pt_vs_eta;
  vector<TH1D*> etaSpectra;

  vector<TH3F*> A3D_histos;
  vector<TH3F*> A3D_histos_truth;
  for (int mi=0;mi<N;++mi) {

    Str prefix=histogramNamePrefix+jetAlgo+"_"+MCsamples[mi]+"_";
    Str truthprefix=truthJetAlgo+"_"+MCsamples[mi]+"_";

    std::cout << "(MC) Prefix: " <<prefix << std::endl;

    h2d_pt_vs_eta.push_back(Get2DHisto(prefix+"PtAvg_vs_EtaDet"));
    std::cout << "Aquired... : " + prefix+"PtAvg_vs_EtaDet" << std::endl;
    if (mi==0) GetBinRange(h2d_pt_vs_eta[0]->GetYaxis(), ptmin, ptmax,lowPtBin, highPtBin);
    etaSpectra.push_back(h2d_pt_vs_eta[mi]->ProjectionX(prefix+ptRangeStr+"_EtaSpectrum",lowPtBin,highPtBin));

    Str suffix="";
    A3D_histos.push_back(GetAsymmetry3DHisto(prefix,lowPtBin,highPtBin,suffix));

    if(_subtractPtclAsym){
      A3D_histos_truth.push_back(GetAsymmetry3DHisto(truthprefix,lowPtBin,highPtBin,suffix));
    }
  }

  for (int mi=0;mi<2;++mi) {
    Str meth=mi==0?"SM":"MM";
    vector<TH2F*> meanHistos;
    for (int jxi=0;jxi<N;++jxi) {
      Str prefix=histogramNamePrefix+jetAlgo+"_"+MCsamples[jxi];
      meanHistos.push_back(Get2DHisto(prefix+"_PtAvgFine_vs_EtaProbe"+meth));
    }
    ExtractPtEtaMean(meanHistos,meth,ptmin,ptmax);

    //free memory
    for (size_t idel = 0; idel < meanHistos.size(); idel++) delete meanHistos[idel];
  }

  MergeHistosAndMinimize(jetAlgo+"_", etaBins, A3D_histos, etaSpectra, MCsamples, A3D_histos_truth);

  //free memory
  for (size_t idel = 0; idel < A3D_histos.size(); idel++) delete A3D_histos[idel];
  for (size_t idel = 0; idel < etaSpectra.size(); idel++) delete etaSpectra[idel];
  for (size_t idel = 0; idel < A3D_histos_truth.size(); idel++) delete A3D_histos_truth[idel];
  for (size_t idel = 0; idel < h2d_pt_vs_eta.size(); idel++) delete h2d_pt_vs_eta[idel];
} // MinimizeMC

void MinimizeData(VecD etaBins) {


  if (_isTrigOR) {



    vector<TH2F*> h2d_pt_vs_eta;
    vector<TH1D*> etaSpectra;

    //h2d_pt_vs_eta.clear();//etaSpectra.clear();

    StrV trigDesc;

    vector<TH3F*> A3D_histos;
    vector<TH3F*> A3D_histos_truth;


    if(trigs.size()==2){

      currentTrigDesc=Str(currentTrig).ReplaceAll("or"," OR ");

      Str prefix=histogramNamePrefix+jetAlgo+"_"+currentTrig+"_";

	    inputFile->cd(jetAlgo);

      if ( gDirectory->Get(prefix+"RefFJ_J_PtAvg_vs_EtaDet")==NULL)
	     prefix=histogramNamePrefix+jetAlgo+"_"+currentTrigLong+"_";

      gROOT->cd();

      int lowPtBin=-1, highPtBin=-1;
      vector<TH2F*> h2d_pt_vs_eta;
      vector<TH1D*> etaSpectra;


      // event classification based on combination method
      vector<TString> classifications;
      if(_isSlimHistos)
      {
        classifications.push_back(prefix+"allJ&FJ_");
        trigDesc.push_back(trigs[0]+"_allJ&FJ");
      }
      else if(_isInclusionTrigComb)
      {
        classifications.push_back(prefix+"rawJ_");
        trigDesc.push_back(trigs[0]+"_rawJ");

        classifications.push_back(prefix+"rawFJ_");
        trigDesc.push_back(trigs[0]+"_rawFJ");

        classifications.push_back(prefix+"rawJ&FJ_");
        trigDesc.push_back(trigs[0]+"_rawJ&FJ");
      }
      else
      {
        classifications.push_back(prefix+"RefFJ_J_");
        trigDesc.push_back(trigs[0]);

        classifications.push_back(prefix+"RefFJ_FJ_");
        trigDesc.push_back(trigs[1]);
      }

      /*
      prefix1.ReplaceAll("EF","").ReplaceAll("a4tc","").ReplaceAll("FS","").ReplaceAll("L2","").ReplaceAll("had","");
      prefix2.ReplaceAll("EF","").ReplaceAll("a4tc","").ReplaceAll("FS","").ReplaceAll("L2","").ReplaceAll("had","");

      trigs[0].ReplaceAll("EF_",""); trigs[0].ReplaceAll("_a4tchad",""); trigs[0].ReplaceAll("_L2FS","");
      trigs[1].ReplaceAll("EF_",""); trigs[1].ReplaceAll("_a4tchad",""); trigs[1].ReplaceAll("_L2FS","");
      */

      printf("    Trig1: %10s\n",trigs[0].Data());
      printf("    Trig2: %10s\n",trigs[1].Data());

      for (size_t iClass = 0; iClass < classifications.size(); iClass++)
      {
        h2d_pt_vs_eta.push_back(Get2DHisto(classifications[iClass]+"PtAvg_vs_EtaDet"));
      }
      // CRASH - for AntiKt6


      GetBinRange(h2d_pt_vs_eta[0]->GetYaxis(), ptmin, ptmax, lowPtBin, highPtBin);

      for (size_t iClass = 0; iClass < classifications.size(); iClass++)
      {
        etaSpectra.push_back(h2d_pt_vs_eta[iClass]->ProjectionX(prefix+trigDesc[iClass]+ptRangeStr+"_EtaSpectrum",lowPtBin,highPtBin));
        etaSpectra[iClass]->SetTitle(jetAlgo+" #eta_{det} distribution, "+ptRangeDesc+", "+trigDesc[iClass]+" from "+currentTrig);
      }

      Str suffix="";
      for (size_t iClass = 0; iClass < classifications.size(); iClass++)
      {
        A3D_histos.push_back(GetAsymmetry3DHisto(classifications[iClass],lowPtBin,highPtBin,suffix));
      }

      //TH1D *testProj = A3D_histos[1]->ProjectionZ("AprojTEST",1,3,4,5);

      if (_isSlimHistos) { if(A3D_histos.size()!=1) error("Something went terribly wrong..."); }
      else if (_isInclusionTrigComb) { if(A3D_histos.size()!=3) error("Something went terribly wrong..."); }
      else if (A3D_histos.size()!=2) error("Something went terribly wrong...");
      int Nevts=0;
      for (size_t iA = 0; iA < A3D_histos.size(); iA++) {
        Nevts += A3D_histos[iA]->GetEntries();
      }

      if (Nevts<50) error(Form("No data for this pT-range! (%d events) ",Nevts));

      if(_subtractPtclAsym){

      int N = MCsamples.size();
	for (int mi=0;mi<N;++mi) {
	  Str truthprefix=truthJetAlgo+"_"+MCsamples[mi];
	  Str suffix="";
	  A3D_histos_truth.push_back(GetAsymmetry3DHistoTruth(truthprefix,lowPtBin,highPtBin,suffix));
	}
      }

      for (int mi=0;mi<2;++mi) {
      	Str meth=mi==0?"SM":"MM";
      	vector<TH2F*> meanHistos;
        TString histSuffix = "PtAvgFine_vs_EtaProbe"+meth;
        for (size_t iClass = 0; iClass < classifications.size(); iClass++)
        {
          meanHistos.push_back(Get2DHisto(classifications[iClass]+histSuffix));
        }

      	ExtractPtEtaMean(meanHistos,meth,ptmin,ptmax);

        //free memory
        for (size_t idel = 0; idel < meanHistos.size(); idel++) delete meanHistos[idel];
      }

      MergeHistosAndMinimize(prefix, etaBins, A3D_histos, etaSpectra, trigDesc, A3D_histos_truth);

      //free memory
      for (size_t idel = 0; idel < A3D_histos.size(); idel++) delete A3D_histos[idel];
      for (size_t idel = 0; idel < etaSpectra.size(); idel++) delete etaSpectra[idel];
      for (size_t idel = 0; idel < A3D_histos_truth.size(); idel++) delete A3D_histos_truth[idel];
      for (size_t idel = 0; idel < h2d_pt_vs_eta.size(); idel++) delete h2d_pt_vs_eta[idel];


    }else if(trigs.size()>2){


      cout<<"    =========================================== MERGING PTAVG BINS =========================================="<<endl;


      Str prefixFULL=currentTrig;

      Str tempTrigStr = currentTrig.ReplaceAll("AND"," ");
      StrV currentTrigORs = Vectorize(tempTrigStr);
      int NcurrentTrigORs = currentTrigORs.size();

      vector<TH2F*> meanHistos_mm;
      vector<TH2F*> meanHistos_sm;

      TH3F *h3dADD_j;
      TH3F *h3dADD_fj;

      TH1D *hADD_etaSpectra_j;
      TH1D *hADD_etaSpectra_fj;

      TH2F *hHadd_ptavg_etaavg_sm_j;
      TH2F *hHadd_ptavg_etaavg_sm_fj;

      TH2F *hHadd_ptavg_etaavg_mm_j;
      TH2F *hHadd_ptavg_etaavg_mm_fj;

      Str prefix1;
      Str prefix2;
      Str suffix;

      int lowPtBin=-1, highPtBin=-1;
      Str TRIGSTR1="", TRIGSTR2="";

      for( int ior=0; ior<NcurrentTrigORs; ior++){

      	Str prefix=histogramNamePrefix+jetAlgo+"_"+currentTrigORs[ior]+"_";

      	prefix1 = prefix+"RefFJ_J_";
      	prefix2 = prefix+"RefFJ_FJ_";

      	Str TRIG1 = trigs[2*ior];
      	Str TRIG2 = trigs[2*ior+1];

      	if(ior<NcurrentTrigORs-1){
      	  TRIGSTR1+=TRIG1+" AND ";
      	  TRIGSTR2+=TRIG2+" AND ";
      	}else{
      	  TRIGSTR1+=TRIG1;
      	  TRIGSTR2+=TRIG2;
      	}
	/*
	prefix1.ReplaceAll("EF","").ReplaceAll("a4tc","").ReplaceAll("FS","").ReplaceAll("L2","").ReplaceAll("had","");
	prefix2.ReplaceAll("EF","").ReplaceAll("a4tc","").ReplaceAll("FS","").ReplaceAll("L2","").ReplaceAll("had","");

	TRIG1.ReplaceAll("EF_",""); TRIG1.ReplaceAll("_a4tchad",""); TRIG1.ReplaceAll("_L2FS","");
	TRIG2.ReplaceAll("EF_",""); TRIG2.ReplaceAll("_a4tchad",""); TRIG2.ReplaceAll("_L2FS","");
	*/
	printf("    Trig1: %10s\n",TRIG1.Data());
	printf("    Trig2: %10s\n",TRIG2.Data());

	float PTMIN = PtBinMap[current_ptRange][ior], PTMAX = PtBinMap[current_ptRange][ior+1];


	TH2F *h2d_pTavgVSdeta_j = Get2DHisto(prefix1+"_PtAvg_vs_EtaDet");
	if(h2d_pTavgVSdeta_j==NULL) error("NULL eta HISTO J");
	TH2F *h2d_pTavgVSdeta_fj = Get2DHisto(prefix2+"_PtAvg_vs_EtaDet");
	if(h2d_pTavgVSdeta_fj==NULL) error("NULL eta HISTO FJ");

	GetBinRange(h2d_pTavgVSdeta_j->GetYaxis(), PTMIN, PTMAX, lowPtBin, highPtBin);

	//cout<< " BIN RANGE LOW  ============ "<<lowPtBin<<endl;
	//cout<< " BIN RANGE HIGH ============ "<<highPtBin<<endl;

	TH1D* etaSpectra_j = h2d_pTavgVSdeta_j->ProjectionX(prefix+TRIG1+ptRangeStr+"_EtaSpectrum",lowPtBin,highPtBin);
	TH1D* etaSpectra_fj = h2d_pTavgVSdeta_fj->ProjectionX(prefix+TRIG2+ptRangeStr+"_EtaSpectrum",lowPtBin,highPtBin);


	Str suffix="";
	TH3F* hist3d_A_j  = GetAsymmetry3DHisto(prefix1,lowPtBin,highPtBin,suffix);
	if(hist3d_A_j->GetSumw2N()==0) hist3d_A_j->Sumw2();
	TH3F* hist3d_A_fj = GetAsymmetry3DHisto(prefix2,lowPtBin,highPtBin,suffix);
	if(hist3d_A_fj->GetSumw2N()==0) hist3d_A_fj->Sumw2();

  TString hist1Name = prefix1+"PtAvgFine_vs_EtaProbeSM";
  if(_isMC)hist1Name = prefix1+"_PtAvgFine_vs_EtaProbeSM";//necessary because I am an idiot, sorry for the uglyness

  TString hist2Name = prefix2+"PtAvgFine_vs_EtaProbeSM";
  if(_isMC)hist2Name = prefix2+"_PtAvgFine_vs_EtaProbeSM";//necessary because I am an idiot, sorry for the uglyness

	TH2F *h_ptavg_etaavg_sm_j  = Get2DHisto(hist1Name);
	TH2F *h_ptavg_etaavg_sm_fj = Get2DHisto(hist2Name);

  hist1Name = prefix1+"PtAvgFine_vs_EtaProbeMM";
  if(_isMC)hist1Name = prefix1+"_PtAvgFine_vs_EtaProbeMM";//necessary because I am an idiot, sorry for the uglyness

  hist2Name = prefix2+"PtAvgFine_vs_EtaProbeMM";
  if(_isMC)hist2Name = prefix2+"_PtAvgFine_vs_EtaProbeMM";//necessary because I am an idiot, sorry for the uglyness

	TH2F *h_ptavg_etaavg_mm_j  = Get2DHisto(hist1Name);
	TH2F *h_ptavg_etaavg_mm_fj = Get2DHisto(hist2Name);

	if(ior==0){
	  hHadd_ptavg_etaavg_sm_j  = (TH2F*)h_ptavg_etaavg_sm_j->Clone();
	  hHadd_ptavg_etaavg_sm_fj = (TH2F*)h_ptavg_etaavg_sm_fj->Clone();
	  hHadd_ptavg_etaavg_mm_j  = (TH2F*)h_ptavg_etaavg_mm_j->Clone();
	  hHadd_ptavg_etaavg_mm_fj = (TH2F*)h_ptavg_etaavg_mm_fj->Clone();
	  hADD_etaSpectra_j = (TH1D*)etaSpectra_j->Clone();
	  hADD_etaSpectra_fj = (TH1D*)etaSpectra_fj->Clone();
	  h3dADD_j = (TH3F*)hist3d_A_j->Clone();
	  h3dADD_fj = (TH3F*)hist3d_A_fj->Clone();
	}else{
	  hHadd_ptavg_etaavg_sm_j->Add(h_ptavg_etaavg_sm_j);
	  hHadd_ptavg_etaavg_sm_fj->Add(h_ptavg_etaavg_sm_fj);
	  hHadd_ptavg_etaavg_mm_j->Add(h_ptavg_etaavg_mm_j);
	  hHadd_ptavg_etaavg_mm_fj->Add(h_ptavg_etaavg_mm_fj);
	  hADD_etaSpectra_j->Add(etaSpectra_j);
	  hADD_etaSpectra_fj->Add(etaSpectra_fj);
	  h3dADD_j->Add(hist3d_A_j);
	  h3dADD_fj->Add(hist3d_A_fj);
	}


      }


      trigDesc.push_back(TRIGSTR1);
      trigDesc.push_back(TRIGSTR2);

      meanHistos_sm.push_back(hHadd_ptavg_etaavg_sm_j);
      meanHistos_sm.push_back(hHadd_ptavg_etaavg_sm_fj);
      meanHistos_mm.push_back(hHadd_ptavg_etaavg_mm_j);
      meanHistos_mm.push_back(hHadd_ptavg_etaavg_mm_fj);
      A3D_histos.push_back( h3dADD_j );
      A3D_histos.push_back( h3dADD_fj );
      etaSpectra.push_back(hADD_etaSpectra_j);
      etaSpectra.push_back(hADD_etaSpectra_fj);


      if (A3D_histos.size()!=2) error("Something went terribly wrong...");
      int Nevts = A3D_histos[0]->GetEntries()+A3D_histos[1]->GetEntries();

      if (Nevts<50) error(Form("No data for this pT-range! (%d events) ",Nevts));

      if(_subtractPtclAsym){
      	int N = MCsamples.size();
      	for (int mi=0;mi<N;++mi) {
      	  Str truthprefix=truthJetAlgo+"_"+MCsamples[mi];
      	  Str suffix="";
      	  A3D_histos_truth.push_back(GetAsymmetry3DHistoTruth(truthprefix,lowPtBin,highPtBin,suffix));
      	}
      }

      ExtractPtEtaMean(meanHistos_sm,"SM",ptmin,ptmax);
      ExtractPtEtaMean(meanHistos_mm,"MM",ptmin,ptmax);
      MergeHistosAndMinimize(prefixFULL, etaBins, A3D_histos, etaSpectra, trigDesc, A3D_histos_truth);

      //free memory
      for (size_t idel = 0; idel < A3D_histos.size(); idel++) delete A3D_histos[idel];
      for (size_t idel = 0; idel < etaSpectra.size(); idel++) delete etaSpectra[idel];
      for (size_t idel = 0; idel < A3D_histos_truth.size(); idel++) delete A3D_histos_truth[idel];
      for (size_t idel = 0; idel < h2d_pt_vs_eta.size(); idel++) delete h2d_pt_vs_eta[idel];


  }else error(" Cannot understand the trigger inputs!!");



  }else {
    error("we should never get here (no trigger ORing)");
  }
} // minimize data

void ExtractPtEtaMean(vector<TH2F*> meanHistos, Str method, double pt_min, double pt_max) {
  int pmin, pmax, emin, emax;

  GetBinRange(meanHistos[0]->GetYaxis(),pt_min,pt_max,pmin,pmax);

  int Nh=meanHistos.size();
  TH2F *h_avgEta = histos2d[jetAlgo+"_AvgEta_vs_EtaPtAvg_"+method];
  if (h_avgEta==NULL) error("Can't access avg eta hist");
  for (int ei=0;ei<_etaBinsSM.size()-1;++ei) {
    double eta_min=_etaBinsSM[ei], eta_max=_etaBinsSM[ei+1];
    GetBinRange(meanHistos[0]->GetXaxis(),eta_min,eta_max,emin,emax);
    //printf("Pt: %.0f-%.0f %d-%d, Eta: (%.1f,%.1f) %d-%d\n",
    //ptmin,ptmax,pmin,pmax,_etaBinsSM[ei],_etaBinsSM[ei+1],emin,emax);
    double sumw=0, sumw2=0, sumwx=0, sumwy=0, sumwxx=0, sumwyy=0;
    for (int ebi=emin;ebi<=emax;++ebi) {
      for (int pbi=pmin;pbi<=pmax;++pbi) {
	      for (int hi=0;hi<Nh;++hi) {
	        double N=meanHistos[hi]->GetBinContent(ebi,pbi);
	        double eta=meanHistos[hi]->GetXaxis()->GetBinCenter(ebi);
	        double pt=meanHistos[hi]->GetYaxis()->GetBinCenter(pbi);

	        sumw += N; sumw2 += N*N; sumwx += N*eta; sumwy += N*pt; sumwxx += N*eta*eta; sumwyy += N*pt*pt;
	        //printf("Bin (%3d,%3d) (%6.2f,%6.2f) has %.3f evetns\n",ebi,pbi,eta,pt,N);
	      }
      }
    }
    double Neff=sumw*sumw/sumw2;
    if ( sumw==0 || Neff<1) continue;
    //printf("sumw: %.3f, Neff = %.3f RMS: %.3f\n",sumw,Neff,sqrt(sumwxx/sumw-sumwx*sumwx/sumw/sumw));
    double avgEta=sumwx/sumw, avgPt=sumwy/sumw;
    double errEta=sqrt((sumwxx/sumw-avgEta*avgEta)/Neff);
    double errPt=sqrt((sumwyy/sumw-avgPt*avgPt)/Neff);
    //printf("Avg eta = %6.3f +/- %6.3f, pT = %6.1f +/- %6.1f\n",avgEta,errEta,avgPt,errPt);

    int xbin=h_avgEta->GetXaxis()->FindBin((eta_min+eta_max)/2);
    int ybin=h_avgEta->GetYaxis()->FindBin((pt_min+pt_max)/2);
    h_avgEta->SetBinContent(xbin,ybin,avgEta);
    h_avgEta->SetBinError(xbin,ybin,errEta);
    histos2d[jetAlgo+"_AvgPtAvg_vs_EtaPtAvg_"+method]->SetBinContent(xbin,ybin,avgPt);
    histos2d[jetAlgo+"_AvgPtAvg_vs_EtaPtAvg_"+method]->SetBinError(xbin,ybin,errPt);
  } // for each eta bin

  //error("stop");
}


double GetSystShiftMM( double lEtaMin,double lEtaMax, double rEtaMin, double rEtaMax ){

  Str hname, hname_empty;


  if(_isMC){
    hname = Form("mc_smooth_3d_%s_%s_pT%.0fto%.0f",
		 jetAlgo.Data(),
		 _systematicShift.Data(),
		 ptRanges[current_ptRange][0],
		 ptRanges[current_ptRange][1]);

    hname_empty = Form("mc_emptyBins_3d_%s_%s_pT%.0fto%.0f",
		       jetAlgo.Data(),
		       _systematicShift.Data(),
		       ptRanges[current_ptRange][0],
		       ptRanges[current_ptRange][1]);

  }else{
    hname = Form("data_smooth_3d_%s_%s_pT%.0fto%.0f",
		 jetAlgo.Data(),
		 _systematicShift.Data(),
		 ptRanges[current_ptRange][0],
		 ptRanges[current_ptRange][1]);

    hname_empty = Form("data_emptyBins_3d_%s_%s_pT%.0fto%.0f",
		       jetAlgo.Data(),
		       _systematicShift.Data(),
		       ptRanges[current_ptRange][0],
		       ptRanges[current_ptRange][1]);

  }


  /*


  if(_isMC){
    hname = Form("mc_rebin_3d_%s_%s_pT%.0fto%.0f",
		 jetAlgo.Data(),
		 _systematicShift.Data(),
		 ptRanges[current_ptRange][0],
		 ptRanges[current_ptRange][1]);

    hname_empty = Form("mc_emptyBins_3d_%s_%s_pT%.0fto%.0f",
		       jetAlgo.Data(),
		       _systematicShift.Data(),
		       ptRanges[current_ptRange][0],
		       ptRanges[current_ptRange][1]);

  }else{
    hname = Form("data_rebin_3d_%s_%s_pT%.0fto%.0f",
		 jetAlgo.Data(),
		 _systematicShift.Data(),
		 ptRanges[current_ptRange][0],
		 ptRanges[current_ptRange][1]);

    hname_empty = Form("data_emptyBins_3d_%s_%s_pT%.0fto%.0f",
		       jetAlgo.Data(),
		       _systematicShift.Data(),
		       ptRanges[current_ptRange][0],
		       ptRanges[current_ptRange][1]);

  }

  */

  double LEtaMidpoint = (lEtaMin+lEtaMax)/2.0;
  double REtaMidpoint = (rEtaMin+rEtaMax)/2.0;

  TH2D *h = (TH2D*)_systematicsFileMM->Get(hname);
  if(h==NULL) error("Can't find histo : "+hname);
  int LEtaBin = h->GetXaxis()->FindBin(LEtaMidpoint);
  int REtaBin = h->GetYaxis()->FindBin(REtaMidpoint);


  //  TH2D *h_empty = (TH2D*)_systematicsFileMM->Get(hname_empty);
  //if(h_empty==NULL) error("Can't find histo : "+hname_empty);
  //if(h_empty->GetBinError( LEtaBin, REtaBin )==0) return -99;

  /*
  if(hname.Contains("rebin") && LEtaBin==REtaBin){
    REtaBin = REtaBin+1;
    cout<<"***************************************************"<<endl;
    cout<<"leta max : min =  "<<lEtaMax<<" : "<<lEtaMin<<endl;
    cout<<"reta max : min =  "<<rEtaMax<<" : "<<rEtaMin<<endl;
    cout<<"LBIN    : "<<LEtaBin<<endl;
    cout<<"RBIN    : "<<REtaBin<<endl;
    cout<<"Leta max : min =  "<<h->GetXaxis()->GetBinLowEdge(LEtaBin+1)<<" : "<<h->GetXaxis()->GetBinLowEdge(LEtaBin)<<endl;
    cout<<"Reta max : min =  "<<h->GetYaxis()->GetBinLowEdge(REtaBin+1)<<" : "<<h->GetYaxis()->GetBinLowEdge(REtaBin)<<endl;
    cout<<"CONTENT : "<<h->GetBinContent( LEtaBin, REtaBin )<<endl;
  }
  */

  return h->GetBinContent( LEtaBin, REtaBin );

}


double GetSystShiftSM( double etaMin, double etaMax ){

  Str hname;
  if(_isMC)
    hname = Form("mc_smooth_%s_%s_pT%.0fto%.0f",
		 jetAlgo.Data(),
		 _systematicShift.Data(),
		 ptRanges[current_ptRange][0],
		 ptRanges[current_ptRange][1]);
  else
    hname = Form("data_smooth_%s_%s_pT%.0fto%.0f",
		 jetAlgo.Data(),
		 _systematicShift.Data(),
		 ptRanges[current_ptRange][0],
		 ptRanges[current_ptRange][1]);

  double etaMidpoint = (etaMin+etaMax)/2.0;

  TH1D *h = (TH1D*)_systematicsFileSM->Get(hname);
  if(h==NULL) error("Can't find systematic histo: "+hname);
  int etaBin = h->GetXaxis()->FindBin(etaMidpoint);

  return 1;

  return (double)h->GetBinContent( etaBin );

}

void MergeHistosAndMinimize(Str prefix, VecD etaBins, vector<TH3F*> A3D_histos, vector<TH1D*> etaSpectra, StrV desc, vector<TH3F*> A3D_histos_truth) {

  printf("\n  ======\n  Matrix method for %s\n",ptRangeDesc.Data()); cout << flush;


  int Nhistos=A3D_histos.size();
  int Nhistos_truth=A3D_histos_truth.size();
  vector<int> MMstats(Nhistos,0), SMstats(Nhistos,0), MMstats_truth(Nhistos_truth,0), SMstats_truth(Nhistos_truth,0);

  int NetaBins = etaBins.size()-1;
  // Create the matrix
  TH2F *matrix = new TH2F(prefix+ptRangeStr+"_matrix",
			  "Response ratio vs (#eta_{left},#eta_{right}) for "+ptRangeDesc,
			  NetaBins,&etaBins[0],NetaBins,&etaBins[0]);

  matrix->SetXTitle(A3D_histos[0]->GetXaxis()->GetTitle());
  matrix->SetYTitle(A3D_histos[0]->GetYaxis()->GetTitle());


  int NbinsSM = _etaBinsSM.size()-1;
  TH1F *R_mm = new TH1F(jetAlgo+"_"+ptRangeStr+"_R_MM","Matrix method relative response "+ptRangeDesc,NbinsSM,&_etaBinsSM[0]);
  TH1F *c_mm = new TH1F(jetAlgo+"_"+ptRangeStr+"_c_MM","Matrix method c-factor "+ptRangeDesc,NbinsSM,&_etaBinsSM[0]);
  for (int i=0;i<=R_mm->GetNbinsX()+1;++i) { R_mm->SetBinContent(i,-99); c_mm->SetBinContent(i,-99); }
  R_mm->SetXTitle("jet #eta_{det}"); c_mm->SetXTitle("jet #eta_{det}");
  R_mm->SetYTitle("Relative response, 1/#font[52]{c}");
  c_mm->SetYTitle("#eta-intercalibration factor #font[52]{c}");
  R_mm->SetMinimum(0.75); R_mm->SetMaximum(1.25); c_mm->SetMinimum(0.75); c_mm->SetMaximum(1.25);
  R_mm->SetMarkerSize(0.6);  c_mm->SetMarkerSize(0.6);

  // make sure all projections DONT get anchored in the file .. just keep 'em in memory (noise reduction!)
  gROOT->cd();

  int Nx=3, Ny=3; int cw=1;
  Can->Clear(); Can->Divide(Nx,Ny);


  //Eta bins combination
  bool isLowNeff, isGetSecondHist, isGetCombinedHistos;
  str_BinCombination *tempCombination;
  vector<str_BinCombination> v_CombinationResults;


  // loop over left and right eta bins
  //for (int li=0;li<NetaBins;++li) {
    //for (int ri=NetaBins-1;ri>=0;--ri) {
  for(int iGr=0;iGr<NetaBins/2;iGr++){
    int ElMax=2*(NetaBins-2-2*iGr)+1;
    int iElMid=(ElMax-1)/2;
    int li, ri;
    for(int iEl=0;iEl<ElMax;iEl++){

      //Eta bins combination
      isLowNeff = isGetSecondHist = isGetCombinedHistos = false;
      GetSecondHist:
      if(iEl<=iElMid) {
        li=iGr;
        ri=iEl+iGr+1;
      }
      else {
        ri=iElMid+iGr+1;
        li=iGr+iEl-iElMid;
      }

      if (li>=ri) continue;

      int lLowBin=-1, lHighBin=-1, rLowBin=-1, rHighBin=-1;
      lEtaMin = etaBins[li], lEtaMax = etaBins[li+1];
      rEtaMin = etaBins[ri], rEtaMax = etaBins[ri+1];

      //Eta bins combination
      GetCombinedHistos:

      vector<TH1D*> Ahistos;
      for (uint hi=0;hi<Nhistos;++hi) {//for (uint hi=0;hi<Nhistos;++hi)
				// x/y axis below doesn't matter - are identical
				GetBinRange(A3D_histos[0]->GetXaxis(), lEtaMin, lEtaMax, lLowBin, lHighBin);
				GetBinRange(A3D_histos[0]->GetYaxis(), rEtaMin, rEtaMax, rLowBin, rHighBin);

				//cout<<"************************************************************"<<endl;
				//printf("eta bin: %d-%d,%d-%d\n",lLowBin,lHighBin,rLowBin,rHighBin);
				//printf("eta range (L,R) : %.1f-%.1f,%.1f-%.1f\n",A3D_histos[0]->GetXaxis()->GetBinLowEdge(lLowBin),A3D_histos[0]->GetXaxis()->GetBinLowEdge(lHighBin),A3D_histos[0]->GetYaxis()->GetBinLowEdge(rLowBin),A3D_histos[0]->GetYaxis()->GetBinLowEdge(rHighBin));

				static int Aproj_i=0;
				TH1D *h = A3D_histos[hi]->ProjectionZ(Form("Aproj_%d",Aproj_i++),lLowBin,lHighBin,rLowBin,rHighBin);
				if(h->GetSumw2N()==0) h->Sumw2();

				/*
				if (_absEta) {
					int llowBinAbs=-1, lhighBinAbs=-1,rlowBinAbs=-1, rhighBinAbs=-1;
					GetBinRange(A3D_histos[0]->GetXaxis(), -etaBins[ri+1], -etaBins[ri], llowBinAbs, lhighBinAbs);
					GetBinRange(A3D_histos[0]->GetYaxis(), -etaBins[li+1], -etaBins[li], rlowBinAbs, rhighBinAbs);
					TH1D *h2 = A3D_histos[hi]->ProjectionZ(Form("Aproj2_%d",Aproj_i++),llowBinAbs,lhighBinAbs,rlowBinAbs,rhighBinAbs);
					InvertAndAdd(h,h2);
				}
				*/
//if( ptRangeDesc.Contains("115") && ptRangeDesc.Contains("145") && hi==1 ) h->Scale(0);
				int N=h->GetEntries();
				if( ! isGetCombinedHistos) MMstats[hi] += N;
				Ahistos.push_back(h);
			}


      TH1D *hA;
      if (Nhistos==1) hA=Ahistos[0];
      else {
	      hA = (TH1D*)Ahistos[0]->Clone();
	      for (uint hi=1;hi<Ahistos.size();++hi) hA->Add(Ahistos[hi]);
      }
      hA->ResetStats();
      //TH1D *hA = (TH1D*)Ahistos[0]->Clone();
      //for (uint hi=1;hi<Ahistos.size();++hi) hA->Add(Ahistos[hi]);

      Can->cd(cw);
      if (cw==Nx*Ny+1) {
 	Can->Print(AsymMM_psFile); cw=1;
	Can->Clear(); Can->Divide(Nx,Ny); Can->cd(cw);
      }


      //printf("  =====================	================== %.1f #leq #eta_{left} < %.1f \n\n",lEtaMin,lEtaMax);
      //printf("  ======================================== %.1f #leq #eta_{right} < %.1f \n\n",rEtaMin,rEtaMax);


      double Neff = hA->GetEffectiveEntries();
      double A=GetMean(hA)//hA->GetMean()
			, dA=MeanErr(hA);
      TF1 *fit = DrawAhistos(hA,Ahistos,desc); cw++;


      tex->SetTextAlign(32); tex->SetTextColor(kBlack);
      tex->DrawLatex(0.91,0.88,ptRangeDesc);
      tex->DrawLatex(0.91,0.83,Form("%.2f #leq #eta_{left} < %.2f",lEtaMin,lEtaMax));
      tex->DrawLatex(0.91,0.78,Form("%.2f #leq #eta_{right} < %.2f",rEtaMin,rEtaMax));

      std::pair <double,double> AdA = JudgeFit(fit,A,dA,Neff);

      //Eta bins combination
      if(Neff<NeffMin && Neff>_doCombNeffMin && iEl+1<ElMax && !isLowNeff && _doEtaBinsCombination)
      {
        isLowNeff = true;
        tempCombination = new str_BinCombination;
      }
      if(isLowNeff && isGetSecondHist && !isGetCombinedHistos)
      {
        //if the combination still is < NeffMin, save the second histo as first, and get a new second
        int NeffComb = Neff + tempCombination->N1;
        if(NeffComb<NeffMin && Neff>_doCombNeffMin && iEl+1<ElMax)
        {
          tempCombination->l1i = li;
          tempCombination->N1 = Neff;
          tempCombination->r1i = ri;
          isGetSecondHist = false;
        }
        else if(NeffComb<NeffMin)
        {
          tex->SetTextSize(0.08);
          tex->DrawLatex(0.22,0.45,Form("stop combine (%d,%d)", tempCombination->l1i, tempCombination->r1i));
          tex->SetTextSize(0.04);
          if(AdA.first!=-99) std::cerr << "JudgeFit() and test combination incompatible" << '\n';
          goto StopCombine;
        }
      }
      if(isLowNeff && !isGetSecondHist && !isGetCombinedHistos)
      {
        tempCombination->l1i = li;
        tempCombination->N1 = Neff;
        tempCombination->r1i = ri;
        iEl++;
        tex->SetTextSize(0.08);
        tex->DrawLatex(0.22,0.45,Form("try to combine (%d,%d", li,ri));//temp
        tex->SetTextSize(0.04);
        isGetSecondHist = true;
        //free memory
        for (size_t idel = 0; idel < Ahistos.size(); idel++) delete Ahistos[idel];
        if(Nhistos!=1) delete hA;
        delete fit;

        goto GetSecondHist;
      }
      if(isLowNeff && isGetSecondHist && !isGetCombinedHistos)
      {
        tex->SetTextSize(0.08);
        tex->DrawLatex(0.22,0.45,Form("try to combine (%d,%d)", tempCombination->l1i, tempCombination->r1i));//temp
        tex->SetTextSize(0.04);
        tempCombination->N2 = Neff;
        tempCombination->l2i = li;
        tempCombination->r2i = ri;
        rEtaMin = etaBins[tempCombination->r1i]; // for projection, specify the range of the combination
        lEtaMin = etaBins[tempCombination->l1i]; // for projection, specify the range of the combination
        isGetCombinedHistos = true;
        //free memory
        for (size_t idel = 0; idel < Ahistos.size(); idel++) delete Ahistos[idel];
        if(Nhistos!=1) delete hA;
        delete fit;

        goto GetCombinedHistos;
      }
      if(isGetCombinedHistos)
      {
        tex->SetTextSize(0.08);
        tex->DrawLatex(0.22,0.45,Form("combination (%d,%d)", tempCombination->l1i, tempCombination->r1i));//temp
        tex->SetTextSize(0.04);
      }

      StopCombine:

      if (AdA.first==-99)
      {
        //free memory
        if(isLowNeff) delete tempCombination;
        for (size_t idel = 0; idel < Ahistos.size(); idel++) delete Ahistos[idel];
        if(Nhistos!=1) delete hA;
        delete fit;

        continue;
      }
      A = AdA.first; dA=AdA.second;


      //Save the result
      double Rratio = (2.0+A)/(2.0-A);
      double dRratio = 4.0/pow(2.0-A,2)*dA;

      if(_doSystematics){
				double shift = GetSystShiftMM(lEtaMin,lEtaMax,rEtaMin,rEtaMax);
				//cout<<"------------------------------------------------------------- shift : "<<shift<<endl;
        if(shift==-99)
        {
          //free memory
          for (size_t idel = 0; idel < Ahistos.size(); idel++) delete Ahistos[idel];
          if(Nhistos!=1) delete hA;
          delete fit;

          continue;
        }
				Rratio *= (1+shift); // syst shifts are in %

      }

      if(_systematicShift && _subtractPtclAsym) error("Code not setup to run systematics using particle subtraction!");
      // subtract the truth (particle level asymmetry) ... if desired, used as a cross-check to the MC response
      if(_subtractPtclAsym){

				Rratio  = -99;
				dRratio = -99;

				vector<TH1D*> Ahistos_truth;
				for (uint hi=0;hi<A3D_histos_truth.size();++hi) {

					// x/y axis below doesn't matter - are identical
					GetBinRange(A3D_histos_truth[0]->GetXaxis(), lEtaMin, lEtaMax, lLowBin, lHighBin);
					GetBinRange(A3D_histos_truth[0]->GetYaxis(), rEtaMin, rEtaMax, rLowBin, rHighBin);

					static int Aproj_i_truth=0;
					TH1D *h_truth = A3D_histos_truth[hi]->ProjectionZ(Form("Aproj_truth_%d",Aproj_i_truth++),lLowBin,lHighBin,rLowBin,rHighBin);
					if(h_truth->GetSumw2N()==0) h_truth->Sumw2();

					/*
					if (_absEta) {
						GetBinRange(A3D_histos_truth[0]->GetXaxis(), -etaBins[ri+1], -etaBins[ri], lLowBin, lHighBin);
						GetBinRange(A3D_histos_truth[0]->GetYaxis(), -etaBins[li+1], -etaBins[li], rLowBin, rHighBin);
						TH1D *h2_truth = A3D_histos_truth[hi]->ProjectionZ(Form("Aproj2_truth_%d",Aproj_i_truth++),lLowBin,lHighBin,rLowBin,rHighBin);
						InvertAndAdd(h_truth,h2_truth);
					}
					*/

					int N_truth=h_truth->GetEntries();
					MMstats_truth[hi] += N_truth;
					Ahistos_truth.push_back(h_truth);

			}

				TH1D *hA_truth;
				if (Nhistos==1) hA_truth=Ahistos_truth[0];
				else {
					hA_truth = (TH1D*)Ahistos_truth[0]->Clone();
					for (uint hi=1;hi<Ahistos_truth.size();++hi) hA_truth->Add(Ahistos_truth[hi]);
				}

				Can->cd(cw);
				if (cw==Nx*Ny+1) {
					Can->Print(AsymMM_psFile); cw=1;
					Can->Clear(); Can->Divide(Nx,Ny); Can->cd(cw);
				}

				double Neff_truth = hA_truth->GetEffectiveEntries();
				double A_truth=GetMean(hA_truth),//hA_truth->GetMean(),
				 dA_truth=MeanErr(hA_truth);
				TF1 *fit_truth = DrawAhistos(hA_truth,Ahistos_truth,desc,false,true); cw++;

				tex->SetTextAlign(32); tex->SetTextColor(kBlack);
				tex->DrawLatex(0.25,0.3,"Truth");
				tex->DrawLatex(0.91,0.88,ptRangeDesc);
				tex->DrawLatex(0.91,0.83,Form("%.2f #leq #eta_{left} < %.2f",lEtaMin,lEtaMax));
				tex->DrawLatex(0.91,0.78,Form("%.2f #leq #eta_{right} < %.2f",rEtaMin,rEtaMax));

				std::pair <double,double> AdA_truth = JudgeFit(fit_truth,A_truth,dA_truth,Neff_truth);
				if (AdA_truth.first==-99)
        {
          //free memory
          for (size_t idel = 0; idel < Ahistos.size(); idel++) delete Ahistos[idel];
          if(Nhistos!=1) delete hA;
          delete fit;

          continue;
        }
				A_truth = AdA_truth.first; dA_truth=AdA_truth.second;

				Rratio = (2.0+( A-A_truth ) )/(2.0-(A-A_truth));
				dRratio = 4.0/pow(2.0-(A-A_truth),2)*sqrt(pow(dA,2)+pow(dA_truth,2));

        //free memory;
        for (size_t idel = 0; idel < Ahistos_truth.size(); idel++) delete Ahistos_truth[idel];
        if(Nhistos_truth!=1) delete hA_truth;
        delete fit_truth;
  	  }
      if(dRratio == 0 || dRratio != dRratio || Rratio != Rratio){
				cout << "dRratio is zero!! skyinpping entry";
        //free memory
        for (size_t idel = 0; idel < Ahistos.size(); idel++) delete Ahistos[idel];
        if(Nhistos!=1) delete hA;
        delete fit;

				continue;
			}

      if( ! isGetCombinedHistos)
      {
        matrix->SetBinContent(li+1,ri+1,Rratio);
        matrix->SetBinError(li+1,ri+1,dRratio);
      }
      else //save bin combinations results
      {
        matrix->SetBinContent(tempCombination->l1i+1,tempCombination->r1i+1,Rratio);
        matrix->SetBinContent(tempCombination->l2i+1,tempCombination->r2i+1,Rratio);
        matrix->SetBinError(tempCombination->l1i+1,tempCombination->r1i+1,dRratio);
        matrix->SetBinError(tempCombination->l2i+1,tempCombination->r2i+1,dRratio);
        tempCombination->R = Rratio;
        tempCombination->dR = dRratio;
        v_CombinationResults.push_back(*tempCombination);

        //free memory
        delete tempCombination;
      }

      //free memory
      for (size_t idel = 0; idel < Ahistos.size(); idel++) delete Ahistos[idel];
      if(Nhistos!=1) delete hA;
      delete fit;
    } // for each left-eta bin
  } // for each right-eta bin

  Can->Print(AsymMM_psFile);
  Can->Clear();



  if(_symmetrizeMatrixEmptyBins){ //is false
    for( int li=0; li<NetaBins; li++ )
      for( int ri=0; ri<NetaBins; ri++ ){
			if (li>=ri) continue;
			double binContent = matrix->GetBinContent(li+1,ri+1);
		//cout<<" etaLbin = "<<li+1<<" : etaL = "<<matrix->GetXaxis()->GetBinCenter(li+1)<<" : etaRbin = "<<ri+1<<" : etaR = "<<matrix->GetYaxis()->GetBinCenter(ri+1)<<" : bin content = "<<binContent<<endl;
			if(binContent>0.0) continue;
				double etaLbinCenter = matrix->GetXaxis()->GetBinCenter(li+1);
				double etaRbinCenter = matrix->GetYaxis()->GetBinCenter(ri+1);
				int etaLbin = matrix->GetXaxis()->FindBin( -etaRbinCenter );
				int etaRbin = matrix->GetXaxis()->FindBin( -etaLbinCenter );
				//cout<<" SETTING MATRIX BIN ("<<etaLbin<<","<<etaRbin<<") = ("<<-etaLbinCenter<<","<<-etaRbinCenter<<") TO 0"<<endl;
				matrix->SetBinContent(etaLbin,etaRbin,0);
				matrix->SetBinError(etaLbin,etaRbin,0);
	    }
  }



  Minimize(matrix, v_CombinationResults);

  TGraphErrors *relR_vs_eta = MakeFinalGraph(PEc_vs_eta, v_PEc_vs_eta);
  for (int i=0;i<relR_vs_eta->GetN(); ++i) {
    double R   = relR_vs_eta->GetY()[i], dR=relR_vs_eta->GetEY()[i], eta = relR_vs_eta->GetX()[i];
    int bin=R_mm->FindBin(eta); R_mm->SetBinContent(bin,R); R_mm->SetBinError(bin,dR);
    c_mm->SetBinContent(bin,1.0/R); c_mm->SetBinError(bin,dR/R/R);
  }
  Can->Clear();

  Can->Divide(2,2);
  tex->SetTextColor(kBlack); tex->SetTextSize(0.025); tex->SetTextAlign(22);
  tex->DrawLatex(0.5,0.5,"#font[62]{Matrix Method Results}");
  tex->SetTextSize(0.04); tex->SetTextAlign(12);

  // 1. eta distribtuion
  Can->cd(1); DrawEtaSpectra(etaSpectra,true,MMstats,"MM statistics");

  // 2. the matrix
  Can->cd(2); gPad->SetRightMargin(0.1); DrawMatrix(matrix);

  // 3. c vs eta
  Can->cd(3);
  gPad->SetRightMargin(0.1); PEc_vs_eta->GetYaxis()->SetRangeUser(0.8,1.20);
  PEc_vs_eta->Draw("colz"); DrawGuideLines(-etaBins[0]); PrintTrigAndPt(true); PrintData();
  c_mm->Draw("same");

  // 4. R vs eta
  Can->cd(4); DrawGraph(relR_vs_eta); PrintTrigAndPt(true);  PrintData();
  //R_mm->Draw("same");

  Can->Print(Result_psFile);

  // Save the hitos and graphs
  outfile->cd(jetAlgo);
  relR_vs_eta->Write(); matrix->Write(); PEc_vs_eta->Write();
  R_mm->Write(); c_mm->Write();

  //free memory
  delete PEc_vs_eta;
  delete relR_vs_eta;
  delete matrix;
  delete R_mm;
  delete c_mm;


  //*/

  /*
   *   The standard method!
   */

  printf("\n  ======\n  Standard method for %s\n",ptRangeDesc.Data()); cout << flush;


  TH1F *A_sm = new TH1F(jetAlgo+"_"+ptRangeStr+"_A_SM","Standard method asymmetry "+ptRangeDesc,NbinsSM,&_etaBinsSM[0]);
  TH1F *R_sm = new TH1F(jetAlgo+"_"+ptRangeStr+"_R_SM","Standard method relative response "+ptRangeDesc,NbinsSM,&_etaBinsSM[0]);
  TH1F *c_sm = new TH1F(jetAlgo+"_"+ptRangeStr+"_c_SM","Standard method c-factor "+ptRangeDesc,NbinsSM,&_etaBinsSM[0]);
  A_sm->SetXTitle("probe jet #eta_{det}"); R_sm->SetXTitle("probe jet #eta_{det}"); c_sm->SetXTitle("probe jet #eta_{det}");
  A_sm->SetYTitle("#LTA#GT"); R_sm->SetYTitle("Relative response, 1/#font[52]{c}");
  c_sm->SetYTitle("#eta-intercalibration factor #font[52]{c}");

  A_sm->SetMinimum(-0.25); A_sm->SetMaximum(0.25);
  R_sm->SetMinimum(0.75); R_sm->SetMaximum(1.25); c_sm->SetMinimum(0.75); c_sm->SetMaximum(1.25);
  for (int i=0;i<=R_sm->GetNbinsX()+1;++i) { R_sm->SetBinContent(i,-99); c_sm->SetBinContent(i,-99); A_sm->SetBinContent(i,-99); }
  A_sm->SetMarkerSize(0.6);  R_sm->SetMarkerSize(0.6);  c_sm->SetMarkerSize(0.6);
  TAxis *fullAxis = A3D_histos[0]->GetXaxis();

  int refLowBin=-1, refHighBin=-1;
  if(!_absEta)
    GetBinRange(fullAxis, -refRegion[1], refRegion[1], refLowBin, refHighBin);
  else
    GetBinRange(fullAxis, 0, refRegion[1], refLowBin, refHighBin);

  if ( fabs(fullAxis->GetBinLowEdge(refLowBin)+refRegion[1]) > 1e-5 && !_absEta ) error(Form("Can't find eta bin-edge at %.2f",-refRegion[1]));
  if ( fabs(fullAxis->GetBinLowEdge(refHighBin+1)-refRegion[1]) > 1e-5 ) error(Form("Can't find eta bin-edge at %.2f",refRegion[1]));

  // make sure all projections DONT get anchored in the file .. just keep 'em in memory (noise reduction!)
  gROOT->cd(); Can->Clear(); Can->Divide(Nx,Ny); cw=1;


  // loop over probe jet eta bins

  //cout<<"SM N ETA BINS    : "<<NbinsSM<<endl;

  for (int etai=0;etai<NbinsSM;++etai) {


    int lowBin=-1, highBin=-1;

    double etaMin = _etaBinsSM[etai], etaMax = _etaBinsSM[etai+1];

    //if (_absEta) GetBinRange(fullAxis, -refRegion[1], refRegion[1], refLowBin, refHighBin);

    GetBinRange(fullAxis, etaMin, etaMax, lowBin, highBin);

    //int lowBinAbs=-1, highBinAbs=-1;
    //GetBinRange(fullAxis, -etaMax, -etaMin, lowBinAbs, highBinAbs);
    //int refLowBinAbs=-1, refHighBinAbs=-1;
    //GetBinRange(fullAxis, -refRegion[1], refRegion[1], refLowBinAbs, refHighBinAbs);


    vector<TH1D*> Ahistos;
    int Nhistos=A3D_histos.size();
    for (uint hi=0;hi<Nhistos;++hi) {
      static int Aproj_i=0;

      // ref is left, probe right - mirrored situation as A = (left-right)/avg !
      TH1D *h1 = A3D_histos[hi]->ProjectionZ(Form("Aproj_sm%d",Aproj_i++),refLowBin,refHighBin,lowBin,highBin);
      // probe is left, ref right
      TH1D *h = A3D_histos[hi]->ProjectionZ(Form("Aproj_sm2%d",Aproj_i++),lowBin,highBin,refLowBin,refHighBin);
      InvertAndAdd(h,h1);
      /*
      if (_absEta) {
	TH1D *h2 = A3D_histos[hi]->ProjectionZ(Form("Aproj_sm3_%d",Aproj_i++), refLowBinAbs, refHighBinAbs,lowBinAbs,highBinAbs);
	TH1D *h3 = A3D_histos[hi]->ProjectionZ(Form("Aproj_sm4_%d",Aproj_i++), lowBinAbs,highBinAbs,refLowBinAbs,refHighBinAbs);
	InvertAndAdd(h3,h2);
	h->Add(h3);
      }
      */
      h->ResetStats();
      SMstats[hi] += h->GetEntries();
      Ahistos.push_back(h);

      //free memory
      delete h1;
    }

    Str Ahname=jetAlgo+"_"+ptRangeStr+"_A_etaBin"; Ahname+=etai;
    TH1D *hA = (TH1D*)Ahistos[0]->Clone(Ahname);
    for (uint hi=1;hi<Ahistos.size();++hi) hA->Add(Ahistos[hi]);
    hA->ResetStats();

    // Save the distribution
    outfile->cd(jetAlgo+"_Histos"); hA->Write(); gROOT->cd();

    Can->cd(cw);
    if (cw==Nx*Ny+1) {
      Can->Print(AsymSM_psFile); cw=1;
      Can->Clear(); Can->Divide(Nx,Ny); Can->cd(cw);
    }

    double Neff = hA->GetEffectiveEntries();
    if (Neff<NeffMin) continue;

    double A=GetMean(hA), dA=MeanErr(hA);
    TF1 *fit = DrawAhistos(hA,Ahistos,desc,true); cw++;

    tex->SetTextAlign(32); tex->SetTextColor(kBlack);
    tex->DrawLatex(0.91,0.88,ptRangeDesc);
    tex->DrawLatex(0.91,0.83,Form("%.1f #leq #eta_{ref} < %.1f",-refRegion[1],refRegion[1]));
    tex->DrawLatex(0.91,0.78,Form("%.1f #leq #eta_{probe} < %.1f",etaMin,etaMax));


    std::pair <double,double> AdA = JudgeFit(fit,A,dA,Neff);
    A = AdA.first; dA = AdA.second;

    A_sm->SetBinContent(etai+1,A);
    A_sm->SetBinError(etai+1,dA);

    double R = (2.0+A)/(2.0-A), dR = 4.0/pow(2.0-A,2)*dA;

    //if(_doSystematics){
    //R *= (1+GetSystShiftSM(etaMin,etaMax)); // syst shifts are in %
    //}


    if(_subtractPtclAsym){

      R = dR = -99;

      vector<TH1D*> Ahistos_truth;
      int Nhistos_truth=A3D_histos_truth.size();
      for (uint hi=0;hi<Nhistos_truth;++hi) {
	static int Aproj_i_truth=0;

	// ref is left, probe right - mirrored situation as A = (left-right)/avg !
	TH1D *h1_truth = A3D_histos_truth[hi]->ProjectionZ(Form("Aproj_truth_sm%d",Aproj_i_truth++),refLowBin,refHighBin,lowBin,highBin);
	// probe is left, ref right
	TH1D *h_truth = A3D_histos_truth[hi]->ProjectionZ(Form("Aproj_truth_sm2%d",Aproj_i_truth++),lowBin,highBin,refLowBin,refHighBin);
	InvertAndAdd(h_truth,h1_truth);

	/*
	if (_absEta) {
	  TH1D *h2_truth = A3D_histos_truth[hi]->ProjectionZ(Form("Aproj_truth_sm3_%d",Aproj_i_truth++), refLowBinAbs, refHighBinAbs,lowBinAbs,highBinAbs);
	  TH1D *h3_truth = A3D_histos_truth[hi]->ProjectionZ(Form("Aproj_truth_sm4_%d",Aproj_i_truth++), lowBinAbs,highBinAbs,refLowBinAbs,refHighBinAbs);
	  InvertAndAdd(h3_truth,h2_truth);
	  h_truth->Add(h3_truth);
	}
	*/

	SMstats_truth[hi] += h_truth->GetEntries();
	Ahistos_truth.push_back(h_truth);

  //free memory
  delete h1_truth;
      }

      Str Ahname_truth=truthJetAlgo+"_"+ptRangeStr+"_A_etaBin"; Ahname+=etai;
      TH1D *hA_truth = (TH1D*)Ahistos_truth[0]->Clone(Ahname_truth);
      for (uint hi=1;hi<Ahistos_truth.size();++hi) hA_truth->Add(Ahistos_truth[hi]);

      Can->cd(cw);
      if (cw==Nx*Ny+1) {
	Can->Print(AsymSM_psFile); cw=1;
	Can->Clear(); Can->Divide(Nx,Ny); Can->cd(cw);
      }

      double Neff_truth = hA_truth->GetEffectiveEntries();
      if (Neff_truth<NeffMin) continue;

      double A_truth=GetMean(hA_truth)//hA_truth->GetMean()
			, dA_truth=MeanErr(hA_truth);
      TF1 *fit_truth = DrawAhistos(hA_truth,Ahistos_truth,desc,true,true); cw++;
      //double Afit = fit->GetParameter(1), dAfit = fit->GetParError(1);

      tex->SetTextAlign(32); tex->SetTextColor(kBlack);
      tex->DrawLatex(0.25,0.3,"Truth");
      tex->DrawLatex(0.91,0.88,ptRangeDesc);
      if(!_absEta) tex->DrawLatex(0.91,0.83,Form("%.1f #leq #eta_{ref} < %.1f",refRegion[0],refRegion[1]));
      else         tex->DrawLatex(0.91,0.83,Form("%.1f #leq #eta_{ref} < %.1f",-refRegion[1],refRegion[1]));
      tex->DrawLatex(0.91,0.78,Form("%.1f #leq #eta_{probe} < %.1f",etaMin,etaMax));

      std::pair <double,double> AdA_truth = JudgeFit(fit_truth,A_truth,dA_truth,Neff_truth);
      A_truth = AdA_truth.first; dA_truth = AdA_truth.second;

      A_sm->SetBinContent(etai+1,A-A_truth);
      A_sm->SetBinError(etai+1,sqrt(pow(dA,2)+pow(dA_truth,2)));

      R = (2.0+(A-A_truth))/(2.0-(A-A_truth)), dR = 4.0/pow(2.0-(A-A_truth),2)*sqrt(pow(dA,2)+pow(dA_truth,2));

      //free memory
      for (size_t idel = 0; idel < Ahistos_truth.size(); idel++) delete Ahistos_truth[idel];
      delete hA_truth;
      delete fit_truth;
    }

    R_sm->SetBinContent(etai+1,R);
    R_sm->SetBinError(etai+1,dR);

    // c = 1/R   dc = 1/R^2 dR
    c_sm->SetBinContent(etai+1,1/R);
    c_sm->SetBinError(etai+1,dR/R/R);

    //free memory
    for (size_t idel = 0; idel < Ahistos.size(); idel++) delete Ahistos[idel];
    delete hA;
    delete fit;
  }
  if (cw!=1) { Can->Print(AsymSM_psFile); }

  /*
   *  Draw the main SM results
   */

  Can->Clear(); Can->Divide(2,2);
  tex->SetTextColor(kBlack); tex->SetTextSize(0.025); tex->SetTextAlign(22);
  tex->DrawLatex(0.5,0.5,"#font[62]{Standard Method Results}");
  tex->SetTextSize(0.04); tex->SetTextAlign(12);

  // 1. Eta spectrum
  Can->cd(1); DrawEtaSpectra(etaSpectra,false,SMstats,"SM statistics");

  // 2. A vs eta
  Can->cd(2); A_sm->SetMarkerSize(0.6); A_sm->Draw(); PrintTrigAndPt(1); PrintData(1);

  // 3. c vs eta
  Can->cd(3); c_sm->SetMarkerSize(0.6); c_sm->Draw(); DrawGuideLines(); c_sm->Draw("same");
  PrintTrigAndPt(1); PrintData(1);

  // 4. R vs eta
  Can->cd(4); R_sm->SetMarkerSize(0.6); R_sm->Draw(); DrawGuideLines(); R_sm->Draw("same");
  PrintTrigAndPt(1); PrintData(1);

  Can->Print(Result_psFile);


  // Save the histos
  outfile->cd(jetAlgo); A_sm->Write(); R_sm->Write(); c_sm->Write();

  std::cout << "end of MergeHistosAndMinimize" << std::endl;

  //free memory
  delete A_sm;
  delete R_sm;
  delete c_sm;
}

std::pair<double,double> JudgeFit(TF1 *fit, double A, double dA, double Neff) {
	bool forceFit = false;
	bool forceMean = false;
  std::pair <double,double> result;

  // Prepare for warning messages
  tex->SetTextAlign(12); tex->SetTextSize(0.08); tex->SetTextColor(kBlack);

  if ( Neff<NeffMin ) {
    tex->DrawLatex(0.22,0.35,Form("Effective entries < %.1f",NeffMin));
    tex->DrawLatex(0.22,0.27,"This bin is ignored."); tex->SetTextSize(0.04);
    result.first = -99; result.second = -99;
    return result;
  }
  if (fit==NULL || forceMean) {
		if(!forceMean)
    tex->DrawLatex(0.22,0.35,"Too course optimal bin-width.");

		if(forceFit || dA <= 0 || dA != dA || A != A){
		  tex->DrawLatex(0.22,0.27,"This bin is ignored."); tex->SetTextSize(0.04);
		  result.first = -99; result.second = -99;
		  return result;
		}
    tex->DrawLatex(0.22,0.27,"Using mean."); tex->SetTextSize(0.04);
    result.first = A; result.second = dA; return result;
  }

  double Afit = fit->GetParameter(1), dAfit = fit->GetParError(1);
  double chi2 = fit->GetChisquare(),  NDF = fit->GetNDF();

  bool badFit =dAfit/dA > 6 || fabs(dAfit) > 0.3 || chi2/NDF>15 || fabs(Afit) >0.3 && fabs(A) < 0.2 ;

  //bool badFit = dAfit/dA > 3 || dAfit > 0.1 || chi2/NDF>15;

  //  if (!_rejectBasedOnBadFit) badFit=false;

  if ( badFit ){
    if ( _rejectBasedOnBadFit ) {
      printf("\n=========== BAD FIT <<=====\n");
      printf("%s\n",ptRangeDesc.Data());
      printf("Mean: %7.4f +/- %6.4f\n",A,dA);
      printf("Fit:  %7.4f +/- %6.4f\n\n",Afit,dAfit);
      tex->DrawLatex(0.28,0.35,"Bad fit!");
      tex->DrawLatex(0.28,0.27,"Bin ignored!");
      tex->SetTextSize(0.04);
      A=-99; dA=-99;
    }else{
      printf("\n=========== BAD FIT <<=====\n");
      printf("%s\n",ptRangeDesc.Data());
      printf("Mean: %7.4f +/- %6.4f\n",A,dA);
      printf("Fit:  %7.4f +/- %6.4f\n\n",Afit,dAfit);
			TString badFitMessage = "Bad Fit!";
			if(dAfit/dA > 6)badFitMessage += " fit error too big";
			if(dAfit > 0.3)badFitMessage += " fit too large";
			if(chi2/NDF>15)badFitMessage += " chi2 too large";

      tex->DrawLatex(0.28,0.35,"Bad fit!");
      tex->DrawLatex(0.28,0.27,"Using mean!");
      tex->SetTextSize(0.04);
    }
  }

  result.first  = -99;
  result.second = -99;
	if(dA > 0){
   result.first = A;
	 result.second = dA;
	}

  if(forceFit){
    result.first  = -99;
    result.second = -99;
	}

  if (_useFit && dAfit > 0 && !badFit && Neff>=NeffMin ) {
    result.first  = Afit;
    result.second = dAfit;
  }

  tex->SetTextSize(0.04);
  return result;
}

void Minimize(TH2F *matrix, vector<str_BinCombination> &v_CombinationResults) {

  // Fill the matrix for minimization
  int NetaBins=matrix->GetNbinsX(); VecD etaBins;
  for (int i=0;i<=NetaBins;++i) etaBins.push_back(matrix->GetXaxis()->GetBinLowEdge(i+1));
  for (Int_t j = 0; j < NetaBins; j++) {
    for (Int_t i = 0; i < NetaBins; i++) {
      if (j==i) { beta[i][j]=0; err[i][j]=0; continue; }
      beta[i][j] = matrix->GetBinContent(i+1,j+1);
      err[i][j] = matrix->GetBinError(i+1,j+1);
      // health check

      if (beta[i][j]<0||beta[i][j]>2||err[i][j]<0||err[i][j]>1){
				beta[i][j]=1;
	//			error(Form("Bad matrix input (response ratio) for bin (leta bin low edge:%.1f,reta bin low edge:%.1f), R: %.3f +/- %.3f",etaBins[i],etaBins[j],beta[i][j],err[i][j]));
	//cout<<" >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>            BAD MATRIX INPUT !!!!! "<<endl;
				Str badMatrixStr = Form("Bad matrix input (response ratio) for bin (leta bin low edge:%.1f,reta bin low edge:%.1f), R: %.3f +/- %.3f",etaBins[i],etaBins[j],beta[i][j],err[i][j]);
				cout<<"   -----  : "<<badMatrixStr<<endl;
      }
    }
  }

  int Ncbins=2000;
  VecD c_bins = MakeUniformVecD(Ncbins,0,2);

  gROOT->cd();
  PEc_vs_eta = new TH2F(Form("%s_%s_PtRange_%.0fto%.0f_PEc_vs_%s",currentTrig.Data(),jetAlgo.Data(),ptmin,ptmax,"Eta"),
			Str("Calibration factor vs ")+("#eta_{det}")+", for "+currentTrigDesc+
			", "+ptRangeDesc,NetaBins,&etaBins[0],Ncbins,&c_bins[0]);


  PEc_vs_eta->SetXTitle("Jet #eta_{det}");
  PEc_vs_eta->SetYTitle("Eta inter-calibration factor, c");

  v_PEc_vs_eta = new vector<float> [NetaBins];// used to store results in vectors rather than histogram

  _Nbins = NetaBins;
  ROOT::Math::GSLMinimizer *min, *min2;
  const double *xs, *xs2;
  double sol[N_BINS_MAX];
  TH1D* alpha_pe;
  TH2F *beta_result, *beta_err;

  // Choose method upon creation between:
  // kConjugateFR, kConjugatePR, kVectorBFGS, kVectorBFGS2, kSteepestDescent
  min = new ROOT::Math::GSLMinimizer( ROOT::Math::kConjugateFR );

  min->SetMaxFunctionCalls(1000000);
  min->SetMaxIterations(500);
  min->SetTolerance(0.01);

  ROOT::Math::Functor f(&BetaMin,NetaBins);

  min->SetFunction(f);

  min2 = new ROOT::Math::GSLMinimizer( ROOT::Math::kVectorBFGS2 );

  min2->SetMaxFunctionCalls(1000000);
  min2->SetMaxIterations(500);
  min2->SetTolerance(0.01);

  min2->SetFunction(f);

  int seed=123456789;
  trand3.SetSeed(seed);

  int Nsuccess=0;
  _FoundMeanFromNominal = false;
  if(n_pe==0) _GetMeanFromNominal = true;
  if(n_pe==1 && !_GetMeanFromNominal)
  {
    n_pe = 0;
    _GetMeanFromNominal = true;
  }
  int GettingMeanFromNominal = _GetMeanFromNominal ? 1 : 0;

  bool doFirst=true, doSecond=true;
  if(_useAnalyticSolution)
  {
    doSecond=false; //doSecond is used to test the minimization for order inversed variavles, not needed in analytic solution
    cout<<"Using analytic solution\n";
  }

  for (int p = 0; p < n_pe + GettingMeanFromNominal; p++) {

    // Setting the free variables to be minimized
    for (Int_t i = 0; i < NetaBins; i++) {
      min->SetVariable(i,  Form("a%d",i), 0.1, 0.01);
      min2->SetVariable(i, Form("a%d",i), 0.1, 0.01);
    }

    if (doFirst) {
      for (Int_t j = 0; j < NetaBins; j++) {
				for (Int_t i = 0; i < NetaBins; i++) {

					if ( beta[i][j] == 0) { beta_pe[i][j] = 0; err_pe[i][j] = 0; continue; }

					//beta_pe[i][j] = random.Gaus(beta[i][j], err[i][j]);
					double gaus;
          if(_GetMeanFromNominal && p==0) gaus=0;
          else gaus=GetGaus();

					beta_pe[i][j] = beta[i][j] + gaus*err[i][j];
					err_pe[i][j] = err[i][j];
					if (err[i][j]<=0) {
						cout<<"beta["<<i<<"]["<<j<<"] = "<<beta[i][j]<<endl;
						cout<<"error["<<i<<"]["<<j<<"] = "<<err[i][j]<<endl;
						error("Wrong err");
					}

					//if (n_pe == 1) beta_pe[i][j] = beta[i][j];
					//printf("Bin %2d %2d : %5.2f +/- %5.2f\n",i,j,beta_pe[i][j],err_pe[i][j]);
				}
      }

      // pe on Eta bins combination results
      for (size_t iv = 0; iv < v_CombinationResults.size(); iv++)
      {
        double gaus;
        if(_GetMeanFromNominal && p==0) gaus=0;
        else gaus=GetGaus();

        v_CombinationResults[iv].R_pe = v_CombinationResults[iv].R + gaus * v_CombinationResults[iv].dR;
      }

      bool success = false;
      if(_useAnalyticSolution)
      {
        xs = AnalyticSolution(success, NetaBins, v_CombinationResults);
      }
      else
      {
        success = min->Minimize();
        xs = min->X();
      }

      if (success) {
				NormalizeAndSaveResults(xs,PEc_vs_eta,v_PEc_vs_eta); ++Nsuccess;
        if(_GetMeanFromNominal && p==0)
        {
          _FoundMeanFromNominal = true;
          cout<<"Got mean from nominal values\n";
        }
      } //else error("first failed");
    }

    // and the second algorithm, plus and minus eta switched in addition
    if (doSecond && !(_GetMeanFromNominal && p==0)) {
      for (Int_t j = 0; j < NetaBins; j++) {
				for (Int_t i = 0; i < NetaBins; i++) {

					if ( beta[i][j] == 0) {
						beta_pe[NetaBins-1-i][NetaBins-1-j]=0; err_pe[NetaBins-1-i][NetaBins-1-j]=0; continue;
					}

					double gaus=GetGaus();
					beta_pe[NetaBins-1-i][NetaBins-1-j] = beta[i][j]+gaus*err[i][j];
					err_pe[NetaBins-1-i][NetaBins-1-j] = err[i][j];
					//if (err[i][j]<=0) error("Wrong err");
					//if (n_pe == 1)
					//	beta_pe[NetaBins-1-i][NetaBins-1-j] = beta[i][j]; // corrected
				}
      }
      bool success = min2->Minimize();
      xs2 = min2->X();
      // swap back the order
      for (uint i=0; i<NetaBins; ++i) sol[i]=xs2[NetaBins-1-i];

      if (success) {
	NormalizeAndSaveResults(sol,PEc_vs_eta,v_PEc_vs_eta);
	// NormalizeAndSaveResults(xs,PEc_vs_eta); // <= wrong!
	++Nsuccess;
      } //else error("second failed");
    }// doSecond
  }
  printf("  N Successful PEs: %d\n",Nsuccess-GettingMeanFromNominal);

  //free memory
  delete min;
  delete min2;
}


// Frederik's minimization function Eq. 5 in ATLAS-CONF-2010-055
double BetaMin(const double *xx) {
  Double_t temp = 0, Xsum = 0;
  //int NetaBins = etaBins.size()-1;
  for (Int_t j = 0; j < _Nbins; j++) {
    for (Int_t i = 0; i < _Nbins; i++) {
      if (beta_pe[i][j] == 0) continue;
      // Sum ( 1/dR_ij (c_i*R_ij-c_j) )^2
      temp +=
	pow( 1.0/(err_pe[i][j]+1E-30), 2 ) *
	pow( (xx[i]*beta_pe[i][j]) - xx[j], 2 );

    }
    Xsum += xx[j];
  }
  temp += pow(10000*((Xsum/_Nbins)-1.0),2);
  return temp;

}

double * AnalyticSolution(bool &success, int NetaBins, vector<str_BinCombination> &v_CombinationResults)
{
  double *A = new double [NetaBins];
  for(int init=0; init<NetaBins; init++) A[init]=0;
  double B[NetaBins];
  for(int init=0; init<NetaBins; init++) B[init]=0;
  TMatrixD U(NetaBins, NetaBins);
  for(int init=0; init<NetaBins; init++)
    for(int init2=0; init2<NetaBins; init2++)
      U(init,init2)=0;

  Lambda = 1E4*NetaBins*NetaBins; //solution is independant of the value of lambda

  //fill the matrices in the form of U*A=B where C_i=A
  for(int a=0; a<NetaBins; a++)
  {
    B[a] = Lambda/NetaBins;
    for(int j=0; j<NetaBins; j++)
    {
      U(a,j) = Lambda/(NetaBins*NetaBins);
    }

    for(int j=0; j<NetaBins; j++)
    {
      if (beta_pe[a][j]==0 && beta_pe[j][a]==0) continue; //for empty bins in the matrix, R and deltaR are 0
      if(j==a)
      {
        continue;
      }
      U(a,j) += a<j? -beta_pe[a][j]/pow(err_pe[a][j],2) : -beta_pe[j][a]/pow(err_pe[j][a],2);
      U(a,a) += a<j? pow(beta_pe[a][j],2)/pow(err_pe[a][j],2) : 1/pow(err_pe[j][a],2);
    }
  }

  //add Eta bins combination results
  for (size_t iv = 0; iv < v_CombinationResults.size(); iv++)
  {
    int v_l1i = v_CombinationResults[iv].l1i;
    int v_l2i = v_CombinationResults[iv].l2i;
    int v_r1i = v_CombinationResults[iv].r1i;
    int v_r2i = v_CombinationResults[iv].r2i;
    double v_N1 = v_CombinationResults[iv].N1;
    double v_N2 = v_CombinationResults[iv].N2;
    double v_R_pe = v_CombinationResults[iv].R_pe;
    double v_dR = v_CombinationResults[iv].dR;

    if(v_l1i==v_l2i) //same left bin, combination of right bins
    {
      U(v_l1i,v_l1i) += pow(v_R_pe/v_dR,2);
      U(v_r1i,v_r1i) += 1.0/pow(v_dR,2) * pow(v_N1/(v_N1+v_N2),2);
      U(v_r2i,v_r2i) += 1.0/pow(v_dR,2) * pow(v_N2/(v_N1+v_N2),2);

      double temp;
      temp = -v_R_pe/pow(v_dR,2) * v_N1/(v_N1+v_N2);
      U(v_l1i,v_r1i) += temp;
      U(v_r1i,v_l1i) += temp;
      temp = -v_R_pe/pow(v_dR,2) * v_N2/(v_N1+v_N2);
      U(v_l1i,v_r2i) += temp;
      U(v_r2i,v_l1i) += temp;
      temp = 1.0/pow(v_dR,2) * v_N1*v_N2/pow(v_N1+v_N2,2);
      U(v_r1i,v_r2i) += temp;
      U(v_r2i,v_r1i) += temp;
    }
    else if(v_r1i==v_r2i) //same right bin, combination of left bins
    {
      U(v_r1i,v_r1i) += pow(1/v_dR,2);
      U(v_l1i,v_l1i) += pow(v_R_pe/v_dR,2) * pow(v_N1/(v_N1+v_N2),2);
      U(v_l2i,v_l2i) += pow(v_R_pe/v_dR,2) * pow(v_N2/(v_N1+v_N2),2);

      double temp;
      temp = -v_R_pe/pow(v_dR,2) * v_N1/(v_N1+v_N2);
      U(v_l1i,v_r1i) += temp;
      U(v_r1i,v_l1i) += temp;
      temp = -v_R_pe/pow(v_dR,2) * v_N2/(v_N1+v_N2);
      U(v_l2i,v_r2i) += temp;
      U(v_r1i,v_l2i) += temp;
      temp = pow(v_R_pe/v_dR,2) * v_N1*v_N2/pow(v_N1+v_N2,2);
      U(v_l1i,v_l2i) += temp;
      U(v_l2i,v_l1i) += temp;
    }
    else
    {
      cout<<"error in combination "<< iv<<endl;
      exit(1);
    }
  }

  double determinant;
  U.Invert(&determinant); //if the matrix couldn't be inverted, the returned value of determinant is zero

  if(determinant==0)
  {
    success = false;
    return A;
  }

  //solution A = U^-1 * B
  for(int i=0; i<NetaBins; i++)
  {
    for(int j=0; j<NetaBins; j++)
    {
      A[i] += U(i,j)*B[j];
    }
  }

  success = true;
  return A;
}

void NormalizeAndSaveResults(const double *xs, TH2F *PEc_vs_Eta, vector<float> *v_PEc_vs_eta) {

  // 1. Find average response in the reference region
  double refRsum=0; int NrefBins=0;
  for (int i=0;i<_Nbins;++i) {
    double eta=PEc_vs_Eta->GetXaxis()->GetBinCenter(i+1);
    //printf("eta: %.2f\n",eta);
    if (isRef(eta)) { refRsum+=xs[i]; NrefBins++; }
  }
  if (NrefBins==0) error(Form("Found %d ref bins?? Check the settings...",NrefBins));

  // average response in reference region
  double refR = refRsum / NrefBins;

  // 2. Save normalized response
  for (Int_t i = 0; i < _Nbins; i++) {
    double eta=PEc_vs_Eta->GetXaxis()->GetBinCenter(i+1);
    PEc_vs_Eta->Fill(eta,xs[i]/refR);
    //printf("eta = %.2f R = %.2f\n",eta,xs[i]/refR);
    v_PEc_vs_eta[i].push_back(xs[i]/refR);
  }
}

/*
TGraphErrors *MakeFinalGraph(TH2F *PEc_vs_eta) {
  Str gname=jetAlgo+"_";
  gname+=currentTrig+"_";
  gname+=Str("R_vs_")+"eta_"+ptRangeStr;
  TGraphErrors *graph = new TGraphErrors();
  int Npoints=0;
  graph->SetName(gname);
  graph->SetTitle("Relative response for "+currentTrigDesc+", "+ptRangeDesc);

  // Reduce noise: Don't want to save all these projections to the outptu file
  // put them in memory instead:
  gROOT->cd();

  TAxis *axis = PEc_vs_eta->GetXaxis();
  for (int bini=1;bini<=axis->GetNbins();++bini) {
    static int proji=0;
    TH1D *h = PEc_vs_eta->ProjectionY(Form("proj%d",proji),bini,bini);
    if (h->Integral()==0) { h->Delete(); continue; }
    double etaMin=axis->GetBinLowEdge(bini);
    double etaMax=axis->GetBinLowEdge(bini+1);
    double eta=(etaMin+etaMax)/2;
    double c = h->GetMean();
    double cErr = h->GetRMS();
    graph->SetPoint(Npoints,eta,1.0/c);
    graph->SetPointError(Npoints,etaMax-eta,cErr/(c*c));
    ++Npoints;
  }
  return graph;
}*/

TGraphErrors *MakeFinalGraph(TH2F *PEc_vs_eta, vector<float> *v_PEc_vs_eta) {
  Str gname=jetAlgo+"_";
  gname+=currentTrig+"_";
  gname+=Str("R_vs_")+"eta_"+ptRangeStr;
  TGraphErrors *graph = new TGraphErrors();
  int Npoints=0;
  graph->SetName(gname);
  graph->SetTitle("Relative response for "+currentTrigDesc+", "+ptRangeDesc);

  // Reduce noise: Don't want to save all these projections to the outptu file
  // put them in memory instead:
  gROOT->cd();

  TAxis *axis = PEc_vs_eta->GetXaxis();
  for (int bini=0;bini<axis->GetNbins();++bini) {
    static int proji=0;
    if(v_PEc_vs_eta[bini].size()==0) { continue; }
    double etaMin=axis->GetBinLowEdge(bini+1);
    double etaMax=axis->GetBinLowEdge(bini+1+1);
    double eta=(etaMin+etaMax)/2;
    double c=0, cErr=0;
    GetMeanAndRMS(&v_PEc_vs_eta[bini], c, cErr);
    graph->SetPoint(Npoints,eta,1.0/c);
    graph->SetPointError(Npoints,etaMax-eta,cErr/(c*c));
    ++Npoints;
    v_PEc_vs_eta->clear();
  }
  return graph;
}


double GetGaus() {
  double gaus=trand3.Gaus(0,1);
  if (maxNsigma<=0) return gaus;
  if (gaus>maxNsigma) gaus=maxNsigma;
  if (gaus<-maxNsigma) gaus=-maxNsigma;
  return gaus;
}

TEnv *Init(Str config) {

  SetAtlasStyle();
  gStyle->SetTitleBorderSize(0); gStyle->SetPalette(1);
  gStyle->SetTitleFillColor(kWhite);
  gStyle->SetTitleOffset(1.2,"X"); gStyle->SetTitleOffset(1.2,"Y");
  gStyle->SetTitleOffset(1.2,"Z");

  tex = new TLatex(); tex->SetNDC(); tex->SetTextSize(0.04);
  line = new TLine();

  TEnv *Settings = OpenSettingsFile(config);

  _etaBinsSM  = VectorizeD(Settings->GetValue("EtaBinsSM_"+_etaBinning,""));
  if (_etaBinsSM.size()==0) error("You need to specify EtaBinsSM in the config");

  VecD tempSMbins;
  if(_absEta){
    for(int ieta=0; ieta<=(_etaBinsSM.size()-1)/2; ieta++){
      tempSMbins.push_back(_etaBinsSM[ieta+(_etaBinsSM.size()-1)/2]);
      cout<<" ETA BINS SM ["<<ieta<<"] = "<<_etaBinsSM[ieta+(_etaBinsSM.size()-1)/2]<<endl;
    }
    _etaBinsSM = tempSMbins;
  }

  // variables read from TVectotT of root file
  TVectorT<double> *isSlim = (TVectorT<double> *)inputFile->Get("isSlim");
  _isSlimHistos = (*isSlim)(0)==1 ? true : false;
  delete isSlim;
  if(!_isMC)
  {
    TVectorT<double> *isInclusion = (TVectorT<double> *)inputFile->Get("isInclusion");
    _isInclusionTrigComb = (*isInclusion)(0)==1 ? true : false;
    delete isInclusion;
  }

  if(_isMC || _subtractPtclAsym ) {
    if(_isSlimHistos) { MCsamples.push_back("allJ"); }
    else { MCsamples = Vectorize(Settings->GetValue(MCgen+".SampleNames","")); }
    cout<<"MC generator          : "<<MCgen<<endl;
    if (MCsamples.size()==0) error("No MC sample info for "+MCgen);
  }

  refRegion = VectorizeD(Settings->GetValue("ReferenceRegion","0.0 0.8") );
  if (refRegion.size()!=2) error("Incorrectly specified ReferencRegion");

  Can = new TCanvas("Can","",800,600);
  AsymMM_psFile = Str(outfileName).ReplaceAll(".root","")+"_AsymMM_distributions.ps";
  AsymSM_psFile = Str(outfileName).ReplaceAll(".root","")+"_AsymSM_distributions.ps";
  Result_psFile = Str(outfileName).ReplaceAll(".root","")+"_Results.ps";
  AsymSM_2_psFile = Str(outfileName).ReplaceAll(".root","")+"_AsymSM_2_distributions.ps";

  Can->Print(AsymMM_psFile+"[");
  Can->Print(AsymSM_psFile+"[");
  Can->Print(AsymSM_2_psFile+"[");
  Can->Print(Result_psFile+"[");

  return Settings;
}


void GetBinRange(TAxis *axis, double min, double max, int &minBin, int &maxBin) {
  int good=0;

  //cout<<"****************************************    NBINS = "<<axis->GetNbins()<<endl;
  //cout<<"axis min = "<<axis->GetBinLowEdge(1)<<endl;
  //cout<<"axis max = "<<axis->GetBinLowEdge(axis->GetNbins())<<endl;
  //cout<<"MIN      = "<<min<<endl;
  //cout<<"MAX      = "<<max<<endl;
  for (uint i=1; i<=axis->GetNbins();++i) {
    double low  = axis->GetBinLowEdge(i);
    double high = axis->GetBinLowEdge(i+1);

    if (fabs(low-min)<1e-5) { minBin=i; good++; }
    if (fabs(high-max)<1e-5) { maxBin=i; good++; }
  }
  if (good!=2) error(Form("GetBinRange failed! %.2fto%.2f and %ito%i",min,max,minBin,maxBin));
  //cout<<" MIN BIN : "<<minBin<<endl;
  //cout<<" MAX BIN : "<<maxBin<<endl;

}


TH3F *GetAsymmetry3DHisto(Str prefix, int lowPtBin, int highPtBin, Str desc="") {
  Str ext="";
  Str NAME = prefix+Form("Asym3D_PtBin%d%s"+desc,lowPtBin,ext.Data());
  cout<<" GETTING ASYMMETRY HISTO : "<<NAME.Data()<<endl;
  if (lowPtBin==highPtBin)
    return Get3DHisto(prefix+Form("Asym3D_PtBin%d%s"+desc,lowPtBin,ext.Data()));

  //this gets the asymmetry histograms of
  cout<< " ADDING 3D HISTOS IN GET ASYMMETRY!!!"<<endl;
  TH3F *h = Get3DHisto(prefix+Form("Asym3D_PtBin%d%s"+desc,lowPtBin,ext.Data()));
  TH3F *comb = (TH3F*)h->Clone();
  for (int bin=lowPtBin+1;bin<=highPtBin;++bin) {
    comb->Add(Get3DHisto(prefix+Form("Asym3D_PtBin%d%s"+desc,bin,ext.Data()))); }
  return comb;
}


TH3F *GetAsymmetry3DHistoTruth(Str prefix, int lowPtBin, int highPtBin, Str desc="") {
  Str ext="";
  if (lowPtBin==highPtBin)
    return GetTruth3DAsym(prefix+Form("Asym3D_PtBin%d%s"+desc,lowPtBin,ext.Data()));
  TH3F *h = GetTruth3DAsym(prefix+Form("Asym3D_PtBin%d%s"+desc,lowPtBin,ext.Data()));
  TH3F *comb = (TH3F*)h->Clone();
  for (int bin=lowPtBin+1;bin<=highPtBin;++bin) {
    comb->Add(GetTruth3DAsym(prefix+Form("Asym3D_PtBin%d%s"+desc,bin,ext.Data()))); }
  return comb;
}




void InvertAndAdd(TH1D *h, TH1D *h2) {
  int Nbins = h->GetNbinsX();
  //cout<<" INVERT and ADD "<<endl;
  //cout<< " NEFF h1 : "<<h->GetEffectiveEntries()<<endl;
  //cout<< " NEFF h2 : "<<h2->GetEffectiveEntries()<<endl;
  if (h->GetSumw2N()==0) h->Sumw2();
  if (h2->GetSumw2N()==0) h2->Sumw2();
  for (int i=0;i<=Nbins+1;++i) {
    int i2 = Nbins+1-i;
    double x1=h->GetBinCenter(i), x2=h2->GetBinCenter(i2);
    double y1=h->GetBinContent(i), y2=h2->GetBinContent(i2);
    double e1=h->GetBinError(i), e2=h2->GetBinError(i2);
    h->SetBinContent(i,y1+y2); h->SetBinError(i,sqrt(e1*e1+e2*e2));
  }
  //cout<< " after add NEFF h1 : "<<h->GetEffectiveEntries()<<endl;

}

#endif
